package unisa.gps.etour.bean;

/**
 * Bean Contenente i dati relativi alle News
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

import java.io.Serializable;
import java.util.Date;

public class BeanNews implements Serializable
{
	private String news;
	private Date dataPubblicazione;
	private Date dataScadenza;
	private int priorita;
	private int id;
	private static final long serialVersionUID = -6249491056436689386L;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pNews
	 * @param pDataPubblicazione
	 * @param pDataScadenza
	 * @param pPriorita
	 * @param pId
	 */
	public BeanNews(String pNews, Date pDataPubblicazione, Date pDataScadenza,
			int pPriorita, int pId)
	{
		setNews(pNews);
		setDataPubblicazione(pDataPubblicazione);
		setDataScadenza(pDataScadenza);
		setPriorita(pPriorita);
		setId(pId);
	}

	/**
	 * Costruttore Vuoto
	 * 
	 */
	public BeanNews()
	{

	}

	/**
	 * Restituisce il valore di dataPubblicazione
	 * 
	 * @return Valore di dataPubblicazione.
	 */
	public Date getDataPubblicazione()
	{
		return dataPubblicazione;
	}

	/**
	 * Imposta il nuovo valore di dataPubblicazione
	 * 
	 * @param pDataPubblicazione Nuovo valore di dataPubblicazione.
	 */
	public void setDataPubblicazione(Date pDataPubblicazione)
	{
		dataPubblicazione = pDataPubblicazione;
	}

	/**
	 * Restituisce il valore di dataScadenza
	 * 
	 * @return Valore di dataScadenza.
	 */
	public Date getDataScadenza()
	{
		return dataScadenza;
	}

	/**
	 * Imposta il nuovo valore di dataScadenza
	 * 
	 * @param pDataScadenza Nuovo valore di dataScadenza.
	 */
	public void setDataScadenza(Date pDataScadenza)
	{
		dataScadenza = pDataScadenza;
	}

	/**
	 * Restituisce il valore di news
	 * 
	 * @return Valore di news.
	 */
	public String getNews()
	{
		return news;
	}

	/**
	 * Imposta il nuovo valore di news
	 * 
	 * @param pNews Nuovo valore di news.
	 */
	public void setNews(String pNews)
	{
		news = pNews;
	}

	/**
	 * Restituisce il valore di priorita
	 * 
	 * @return Valore di priorita.
	 */
	public int getPriorita()
	{
		return priorita;
	}

	/**
	 * Imposta il nuovo valore di priorita
	 * 
	 * @param pPriorita Nuovo valore di priorita.
	 */
	public void setPriorita(int pPriorita)
	{
		priorita = pPriorita;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
