package unisa.gps.etour.bean;
import java.io.Serializable;
/**
 * Bean Contenente i dati relativi ai Piatti
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanOperatorePuntoDiRistoro implements Serializable
{
	private int id;
	private String nome;
	private String cognome;
	private String username;
	private String password;
	private String email;
	private int idPuntoDiRistoro;
	private static final long serialVersionUID = -6485826396352557404L;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pNome
	 * @param pCognome
	 * @param pUsername
	 * @param pPassword
	 * @param pEmail
	 * @param pIdPuntoDiRistoro
	 */
	public BeanOperatorePuntoDiRistoro(int pId, String pNome, String pCognome,
			String pUsername, String pPassword, String pEmail,
			int pIdPuntoDiRistoro)
	{
		setId(pId);
		setNome(pNome);
		setCognome(pCognome);
		setUsername(pUsername);
		setPassword(pPassword);
		setEmail(pEmail);
		setIdPuntoDiRistoro(pIdPuntoDiRistoro);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanOperatorePuntoDiRistoro()
	{

	}

	/**
	 * Restituisce il valore di cognome
	 * 
	 * @return Valore di cognome.
	 */
	public String getCognome()
	{
		return cognome;
	}

	/**
	 * Imposta il nuovo valore di cognome
	 * 
	 * @param pCognome Nuovo valore di cognome.
	 */
	public void setCognome(String pCognome)
	{
		cognome = pCognome;
	}

	/**
	 * Restituisce il valore di email
	 * 
	 * @return Valore di email.
	 */
	public String getEmail()
	{
		return email;
	}

	/**
	 * Imposta il nuovo valore di email
	 * 
	 * @param pEmail Nuovo valore di email.
	 */
	public void setEmail(String pEmail)
	{
		email = pEmail;
	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 * 
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di password
	 * 
	 * @return Valore di password.
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * Imposta il nuovo valore di password
	 * 
	 * @param pPassword Nuovo valore di password.
	 */
	public void setPassword(String pPassword)
	{
		password = pPassword;
	}

	/**
	 * Restituisce il valore di username
	 * 
	 * @return Valore di username.
	 */
	public String getUsername()
	{
		return username;
	}

	/**
	 * Imposta il nuovo valore di username
	 * 
	 * @param pUsername Nuovo valore di username.
	 */
	public void setUsername(String pUsername)
	{
		username = pUsername;
	}

	/**
	 * Restituisce il valore di idPuntoDiRistoro
	 * 
	 * @return Valore di idPuntoDiRistoro.
	 */
	public int getIdPuntoDiRistoro()
	{
		return idPuntoDiRistoro;
	}

	/**
	 * Imposta il nuovo valore di idPuntoDiRistoro
	 *
	 * @param pIdPuntoDiRistoro Nuovo valore di idPuntoDiRistoro.
	 */
	public void setIdPuntoDiRistoro(int pIdPuntoDiRistoro)
	{
		idPuntoDiRistoro = pIdPuntoDiRistoro;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
