package unisa.gps.etour.bean;
import java.io.Serializable;

/**
 * Bean Contenente i dati relativi ai Piatti
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

public class BeanPiatto implements Serializable
{
	private int id;
	private String nome;
	private double prezzo;
	private int idMenu;
	private static final long serialVersionUID = -3775462843748984482L;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pNome
	 * @param pPrezzo
	 * @param pIdMenu
	 */
	public BeanPiatto(int pId, String pNome, double pPrezzo, int pIdMenu)
	{
		setId(pId);
		setNome(pNome);
		setPrezzo(pPrezzo);
		setIdMenu(pIdMenu);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanPiatto()
	{

	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 * 
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di prezzo
	 * 
	 * @return Valore di prezzo.
	 */
	public double getPrezzo()
	{
		return prezzo;
	}

	/**
	 * Imposta il nuovo valore di prezzo
	 * 
	 * @param pPrezzo Nuovo valore di prezzo.
	 */
	public void setPrezzo(double pPrezzo)
	{
		prezzo = pPrezzo;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Restituisce il valore di idMenu
	 * 
	 * @return Valore di idMenu.
	 */
	public int getIdMenu()
	{
		return idMenu;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

	/**
	 * Imposta il nuovo valore di idMenu
	 * 
	 * @param pIdMenu Nuovo valore di idMenu.
	 */
	public void setIdMenu(int pIdMenu)
	{
		idMenu = pIdMenu;
	}

}
