package unisa.gps.etour.bean;
import java.io.Serializable;

/**
 * Bean contenente dati relativi alle preferenze di ricerca
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanPreferenzaDiRicerca implements Serializable
{
	private static final long serialVersionUID = 7576354037868937929L;
	private int id;
	private String nome;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pNome
	 */
	public BeanPreferenzaDiRicerca(int pId, String pNome)
	{
		setId(pId);
		setNome(pNome);
	}

	/**
	 * Costruttore Vuoto
	 * 
	 */
	public BeanPreferenzaDiRicerca()
	{

	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 * 
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
