package unisa.gps.etour.bean;
import java.io.Serializable;
import java.util.Date;

import unisa.gps.etour.util.Punto3D;
/**
 * Bean per l'immagazzinazione dei dati del punto di ristoro
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

public class BeanPuntoDiRistoro implements Serializable
{
	private static final long serialVersionUID = 8417686685147484931L;
	private int id;
	private int numeroVoti;
	private double mediaVoti;
	private String nome;
	private String descrizione;
	private String telefono;
	private String localita;
	private String citta;
	private String via;
	private String cap;
	private String provincia;
	private String partitaIva;
	private Punto3D posizione;
	private Date orarioApertura;
	private Date orarioChiusura;
	private String giornoChiusura;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pNumeroVoti
	 * @param pMediaVoti
	 * @param pNome
	 * @param pDescrizione
	 * @param pTelefono
	 * @param pLocalita
	 * @param pCitta
	 * @param pVia
	 * @param pCap
	 * @param pProvincia
	 * @param pPartitaIva
	 * @param pPosizione
	 * @param pOrarioApertura
	 * @param pOrarioChiusura
	 * @param pGiornoChiusura
	 */
	public BeanPuntoDiRistoro(int pId, int pNumeroVoti, double pMediaVoti,
			String pNome, String pDescrizione, String pTelefono,
			String pLocalita, String pCitta, String pVia, String pCap,
			String pProvincia, String pPartitaIva, Punto3D pPosizione,
			Date pOrarioApertura, Date pOrarioChiusura, String pGiornoChiusura)
	{
		setId(pId);
		setNumeroVoti(pNumeroVoti);
		setMediaVoti(pMediaVoti);
		setNome(pNome);
		setDescrizione(pDescrizione);
		setTelefono(pTelefono);
		setLocalita(pLocalita);
		setCitta(pCitta);
		setVia(pVia);
		setCap(pCap);
		setProvincia(pProvincia);
		setPartitaIva(pPartitaIva);
		setPosizione(pPosizione);
		setOrarioApertura(pOrarioApertura);
		setOrarioChiusura(pOrarioChiusura);
		setGiornoChiusura(pGiornoChiusura);
	}

	/**
	 * Costruttore Vuoto
	 * 
	 */
	public BeanPuntoDiRistoro()
	{

	}

	/**
	 * Restituisce il valore di cap
	 * 
	 * @return Valore di cap.
	 */
	public String getCap()
	{
		return cap;
	}

	/**
	 * Imposta il nuovo valore di cap
	 *
	 * @param pCap Nuovo valore di cap.
	 */
	public void setCap(String pCap)
	{
		cap = pCap;
	}

	/**
	 * Restituisce il valore di citta
	 * 
	 * @return Valore di citta.
	 */
	public String getCitta()
	{
		return citta;
	}

	/**
	 * Imposta il nuovo valore di citta
	 *
	 * @param pCitta Nuovo valore di citta.
	 */
	public void setCitta(String pCitta)
	{
		citta = pCitta;
	}

	/**
	 * Restituisce il valore di descrizione
	 * 
	 * @return Valore di descrizione.
	 */
	public String getDescrizione()
	{
		return descrizione;
	}

	/**
	 * Imposta il nuovo valore di descrizione
	 *
	 * @param pDescrizione Nuovo valore di descrizione.
	 */
	public void setDescrizione(String pDescrizione)
	{
		descrizione = pDescrizione;
	}

	/**
	 * Restituisce il valore di giornoChiusura
	 * 
	 * @return Valore di giornoChiusura.
	 */
	public String getGiornoChiusura()
	{
		return giornoChiusura;
	}

	/**
	 * Imposta il nuovo valore di giornoChiusura
	 *
	 * @param pGiornoChiusura Nuovo valore di giornoChiusura.
	 */
	public void setGiornoChiusura(String pGiornoChiusura)
	{
		giornoChiusura = pGiornoChiusura;
	}

	/**
	 * Restituisce il valore di localita
	 * 
	 * @return Valore di localita.
	 */
	public String getLocalita()
	{
		return localita;
	}

	/**
	 * Imposta il nuovo valore di localita
	 *
	 * @param pLocalita Nuovo valore di localita.
	 */
	public void setLocalita(String pLocalita)
	{
		localita = pLocalita;
	}

	/**
	 * Restituisce il valore di mediaVoti
	 * 
	 * @return Valore di mediaVoti.
	 */
	public double getMediaVoti()
	{
		return mediaVoti;
	}

	/**
	 * Imposta il nuovo valore di mediaVoti
	 *
	 * @param pMediaVoti Nuovo valore di mediaVoti.
	 */
	public void setMediaVoti(double pMediaVoti)
	{
		mediaVoti = pMediaVoti;
	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 *
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di numeroVoti
	 * 
	 * @return Valore di numeroVoti.
	 */
	public int getNumeroVoti()
	{
		return numeroVoti;
	}

	/**
	 * Imposta il nuovo valore di numeroVoti
	 *
	 * @param pNumeroVoti Nuovo valore di numeroVoti.
	 */
	public void setNumeroVoti(int pNumeroVoti)
	{
		numeroVoti = pNumeroVoti;
	}

	/**
	 * Restituisce il valore di orarioApertura
	 * 
	 * @return Valore di orarioApertura.
	 */
	public Date getOrarioApertura()
	{
		return orarioApertura;
	}

	/**
	 * Imposta il nuovo valore di orarioApertura
	 *
	 * @param pOrarioApertura Nuovo valore di orarioApertura.
	 */
	public void setOrarioApertura(Date pOrarioApertura)
	{
		orarioApertura = pOrarioApertura;
	}

	/**
	 * Restituisce il valore di orarioChiusura
	 * 
	 * @return Valore di orarioChiusura.
	 */
	public Date getOrarioChiusura()
	{
		return orarioChiusura;
	}

	/**
	 * Imposta il nuovo valore di orarioChiusura
	 *
	 * @param pOrarioChiusura Nuovo valore di orarioChiusura.
	 */
	public void setOrarioChiusura(Date pOrarioChiusura)
	{
		orarioChiusura = pOrarioChiusura;
	}

	/**
	 * Restituisce il valore di partitaIva
	 * 
	 * @return Valore di partitaIva.
	 */
	public String getPartitaIva()
	{
		return partitaIva;
	}

	/**
	 * Imposta il nuovo valore di partitaIva
	 *
	 * @param pPartitaIva Nuovo valore di partitaIva.
	 */
	public void setPartitaIva(String pPartitaIva)
	{
		partitaIva = pPartitaIva;
	}

	/**
	 * Restituisce il valore di posizione
	 * 
	 * @return Valore di posizione.
	 */
	public Punto3D getPosizione()
	{
		return posizione;
	}

	/**
	 * Imposta il nuovo valore di posizione
	 *
	 * @param pPosizione Nuovo valore di posizione.
	 */
	public void setPosizione(Punto3D pPosizione)
	{
		posizione = pPosizione;
	}

	/**
	 * Restituisce il valore di provincia
	 * 
	 * @return Valore di provincia.
	 */
	public String getProvincia()
	{
		return provincia;
	}

	/**
	 * Imposta il nuovo valore di provincia
	 *
	 * @param pProvincia Nuovo valore di provincia.
	 */
	public void setProvincia(String pProvincia)
	{
		provincia = pProvincia;
	}

	/**
	 * Restituisce il valore di telefono
	 * 
	 * @return Valore di telefono.
	 */
	public String getTelefono()
	{
		return telefono;
	}

	/**
	 * Imposta il nuovo valore di telefono
	 *
	 * @param pTelefono Nuovo valore di telefono.
	 */
	public void setTelefono(String pTelefono)
	{
		telefono = pTelefono;
	}

	/**
	 * Restituisce il valore di via
	 * 
	 * @return Valore di via.
	 */
	public String getVia()
	{
		return via;
	}

	/**
	 * Imposta il nuovo valore di via
	 *
	 * @param pVia Nuovo valore di via.
	 */
	public void setVia(String pVia)
	{
		via = pVia;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
