package unisa.gps.etour.bean;

/**
 * Bean Contenente i dati relativi a un Tag
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

import java.io.Serializable;

public class BeanTag implements Serializable
{
	private static final long serialVersionUID = -6320421006595188597L;
	private int id;
	private String nome;
	private String descrizione;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pNome
	 * @param pDescrizione
	 */
	public BeanTag(int pId, String pNome, String pDescrizione)
	{
		setId(pId);
		setNome(pNome);
		setDescrizione(pDescrizione);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanTag()
	{

	}

	/**
	 * Restituisce il valore di descrizione
	 * 
	 * @return Valore di descrizione.
	 */
	public String getDescrizione()
	{
		return descrizione;
	}

	/**
	 * Imposta il nuovo valore di descrizione
	 * 
	 * @param pDescrizione Nuovo valore di descrizione.
	 */
	public void setDescrizione(String pDescrizione)
	{
		descrizione = pDescrizione;
	}

	/**
	 * Restituisce il valore di name
	 * 
	 * @return Valore di name.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di name
	 * 
	 * @param pNome Nuovo valore di name.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
