package unisa.gps.etour.bean;
import java.io.Serializable;
import java.util.Date;
/**
 * Bean Contenente i dati relativi ai feedback di un Bene Culturale
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanVisitaBC implements Serializable
{
	private static final long serialVersionUID = 3331567128449243852L;
	private int voto;
	private int idBeneCulturale;
	private String commento;
	private int IdTurista;
	private Date dataVisita;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pVoto
	 * @param pIdBeneCulturale
	 * @param pCommento
	 * @param pIdTurista
	 * @param pDataVisita
	 */
	public BeanVisitaBC(int pVoto, int pIdBeneCulturale,
			String pCommento, int pIdTurista, Date pDataVisita)
	{
		setVoto(pVoto);
		setIdBeneCulturale(pIdBeneCulturale);
		setCommento(pCommento);
		setIdTurista(pIdTurista);
		setDataVisita(pDataVisita);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanVisitaBC()
	{

	}

	/**
	 * Restituisce il valore di commento
	 * 
	 * @return Valore di commento.
	 */
	public String getCommento()
	{
		return commento;
	}

	/**
	 * Imposta il nuovo valore di commento
	 * 
	 * @param pCommento Nuovo valore di commento.
	 */
	public void setCommento(String pCommento)
	{
		commento = pCommento;
	}

	/**
	 * Restituisce il valore di dataVisita
	 * 
	 * @return Valore di dataVisita.
	 */
	public Date getDataVisita()
	{
		return dataVisita;
	}

	/**
	 * Imposta il nuovo valore di dataVisita
	 * 
	 * @param pDataVisita Nuovo valore di dataVisita.
	 */
	public void setDataVisita(Date pDataVisita)
	{
		dataVisita = pDataVisita;
	}

	/**
	 * Restituisce il valore di idBeneCulturale
	 * 
	 * @return Valore di idBeneCulturale.
	 */
	public int getIdBeneCulturale()
	{
		return idBeneCulturale;
	}

	/**
	 * Imposta il nuovo valore di idBeneCulturale
	 * 
	 * @param pIdBeneCulturale Nuovo valore di idBeneCulturale.
	 */
	public void setIdBeneCulturale(int pIdBeneCulturale)
	{
		idBeneCulturale = pIdBeneCulturale;
	}

	/**
	 * Restituisce il valore di IdTurista
	 * 
	 * @return Valore di IdTurista.
	 */
	public int getIdTurista()
	{
		return IdTurista;
	}

	/**
	 * Imposta il nuovo valore di IdTurista
	 * 
	 * @param pIdTurista Nuovo valore di IdTurista.
	 */
	public void setIdTurista(int pIdTurista)
	{
		IdTurista = pIdTurista;
	}

	/**
	 * Restituisce il valore di voto
	 * 
	 * @return Valore di voto.
	 */
	public int getVoto()
	{
		return voto;
	}

	/**
	 * Imposta il nuovo valore di voto
	 * 
	 * @param pVoto Nuovo valore di voto.
	 */
	public void setVoto(int pVoto)
	{
		voto = pVoto;
	}

	

}
