package unisa.gps.etour.control;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

import unisa.gps.etour.control.GestioneBeniCulturali.GestioneBeniCulturaliComune;
import unisa.gps.etour.control.GestioneBeniCulturali.IGestioneBeniCulturaliComune;

/**
 * Questo è l'entry point del control server. Questa classe ha il compito di
 * effettuare il deploy dei servizi sul registro RMI, rendendo di conseguenza i
 * servizi disponibili ed utilizzabili.
 * 
 * @author De Simone Michelangelo
 * @version 0.1 &#169; 2007 eTour Project - Copyright by SE@SA Lab DMI - University of Salerno
 */
public class ControlServerLauncher
{
	/**
	 * Entry point del ControlServer
	 * 
	 * @param args I parametri da riga di comando
	 */
	public static void main(String[] args)
	{
		// *** ATTENZIONE *** SPERIMENTALE *** ATTENZIONE *** SPERIMENTALE
				
		try
		{
			// GestioneBeniCulturaliComune è la classe che realizza l'interfaccia IGestioneBeniCulturaliComune,
			// interfaccia presente sia sul CLIENTE, sia sul SERVER
			GestioneBeniCulturaliComune gBCC = new GestioneBeniCulturaliComune();
			
			// Qui si crea lo stub per il registry, facendo capire al sistema RMI che si sta esportando l'oggetto gBCC su una
			// porta anonima
			IGestioneBeniCulturaliComune stubGBCC = (IGestioneBeniCulturaliComune)UnicastRemoteObject.exportObject(gBCC, 0);
			
			// Si procede a chiamare il registro (di default è su localhost) e si "binda" (lega)
			Registry registry = LocateRegistry.getRegistry();
			registry.bind("IGestioneBeniCulturaliComune", stubGBCC);
		}
		catch (Exception e)
		{
			System.err.println("Eccezione: " + e.getLocalizedMessage());
		}
	}
}
