/**
 * Classe che implementa l'interfaccia dell'Operatore Agenzia
 *
 * @author Martone Giuseppe
 * @version 0.1
 * 
 * &#169; 2007 eTour Project - Copyright by SE@SA Lab DMI - University of Salerno
 */
package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import unisa.gps.etour.bean.BeanOperatoreAgenzia;

public class DBOperatoreAgenzia implements IDBOperatoreAgenzia
{

	/* (non-Javadoc)
	 * @see unisa.gps.etour.repository.IDBOperatoreAgenzia#ottieniOperatoreAgenzia(int)
	 */
	public BeanOperatoreAgenzia ottieniOperatoreAgenzia(String pUsername)
			throws SQLException
	{
		//Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Resut set dove verra inserito l'output della query
		ResultSet result = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();
			// Query
			String query = "SELECT * FROM operatoreagenzia WHERE Username ='"
					+ pUsername + "'";
			result = stat.executeQuery(query);
			BeanOperatoreAgenzia oa = null;
			if (result.next())
			{
				// Si genera Il bean nel caso in cui la query restituisca un
				// valore
				// altrimenti verra restituito null
				oa = new BeanOperatoreAgenzia();
				oa.setId(result.getInt("Id"));
				oa.setUsername(result.getString("Username"));
				oa.setNome(result.getString("Nome"));
				oa.setCognome(result.getString("Cognome"));
				oa.setPassword(result.getString("Password"));
			}
			return oa;
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude il result set solo se e' stata effettuata la query
			if (result != null)
			{
				result.close();
			}
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	/* (non-Javadoc)
	 * @see unisa.gps.etour.repository.IDBOperatoreAgenzia#modificaPassword(java.lang.String)
	 */
	public boolean modificaPassword(BeanOperatoreAgenzia pOa) throws SQLException
	{
		//Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();

			// Query
			String query = "UPDATE operatoreagenzia SET " + "Password ='"
					+ pOa.getPassword() + "' WHERE Id =" + pOa.getId();
			// Si esegue la query
			int i = stat.executeUpdate(query);

			return (i == 1);
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}	
}
