package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanPreferenzaDiRicerca;

/**
 * Classe che implementa l'interfaccia PreferenzeDiRicerca
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBPreferenzeDiRicerca implements IDBPreferenzeDiRicerca
{
	// Costruttore vuoto
	public DBPreferenzeDiRicerca()
	{
	}

	public boolean cancellaPreferenzaDiRicerca(int pIdPreferenza)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM preferenzediricerca WHERE Id ="
					+ pIdPreferenza;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean cancellaPreferenzaDiRicercaBC(int pIdBeneCulturale,
			int pIdPreferenzaDiRicerca) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM associazionebc WHERE IdPreferenzeDiRicerca = "
					+ pIdPreferenzaDiRicerca
					+ " AND IdBeneCulturale = "
					+ pIdBeneCulturale;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean cancellaPreferenzaDiRicercaPR(int pIdPuntoDiRistoro,
			int pIdPreferenza) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM associazionepr WHERE IdPreferenzeDiRicerca = "
					+ pIdPreferenza
					+ " AND IdPuntoDiRistoro =  "
					+ pIdPuntoDiRistoro;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public boolean cancellaPreferenzaDiRicercaTurista(int pIdTurista,
			int pIdPreferenza) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM gradimento WHERE IdTurista = "
					+ pIdTurista + " AND IdPreferenzeDiRicerca =  "
					+ pIdPreferenza;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public boolean inserisciPreferenzaDiRicercaDelBC(int pIdBeneCulturale,
			int pIdPreferenzaDiRicerca) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO associazionebc(IdPreferenzeDiRicerca, IdBeneCulturale) VALUES ("
					+ pIdPreferenzaDiRicerca + " ," + pIdBeneCulturale + ")";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public boolean inserisciPreferenzaDiRicerca(
			BeanPreferenzaDiRicerca pPreferenza) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO preferenzediricerca(Id, Nome) VALUES ("
					+ pPreferenza.getId() + " ,'" + pPreferenza.getNome()
					+ "')";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean inserisciPreferenzaDiRicercaDelPR(int pIdPuntoDiRistoro,
			int pIdPreferenzaDiRicerca) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO associazionepr(IdPreferenzeDiRicerca, IdPuntoDiRistoro) VALUES ("
					+ pIdPreferenzaDiRicerca + " ," + pIdPuntoDiRistoro + ")";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean inserisciPreferenzaDiRicercaDelTurista(int pIdTurista,
			int pIdPreferenzaDiRicerca) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO gradimento(IdTurista, IdPreferenzeDiRicerca) VALUES ("
					+ pIdTurista + " ," + pIdPreferenzaDiRicerca + ")";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPreferenzaDiRicerca> ottieniPreferenzeDiRicercaDelBC(
			int pIdBeneCulturale) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle preferenze di ricerca di
			// un bene culturale
			String query = "SELECT * FROM associazionebc,preferenzediricerca WHERE IdBeneCulturale = "
					+ pIdBeneCulturale
					+ " AND IdPreferenzeDiRicerca = preferenzediricerca.Id ";
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPreferenzaDiRicerca
			ArrayList<BeanPreferenzaDiRicerca> lista = new ArrayList<BeanPreferenzaDiRicerca>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo i BeanPreferenzaDiRicerca alla lista
				lista.add(new BeanPreferenzaDiRicerca(result.getInt("Id"),
						result.getString("Nome")));
			}
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public ArrayList<BeanPreferenzaDiRicerca> ottieniPreferenzeDiRicercaDelPR(
			int pIdPuntoDiRistoro) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle preferenze di ricerca di
			// un punto di ristoro
			String query = "SELECT * FROM associazionepr,preferenzediricerca WHERE IdPuntoDiRistoro = "
					+ pIdPuntoDiRistoro
					+ " AND IdPreferenzeDiRicerca = preferenzediricerca.Id ";
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPreferenzaDiRicerca
			ArrayList<BeanPreferenzaDiRicerca> lista = new ArrayList<BeanPreferenzaDiRicerca>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo i BeanPreferenzaDiRicerca alla lista
				lista.add(new BeanPreferenzaDiRicerca(result.getInt("Id"),
						result.getString("Nome")));
			}
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public ArrayList<BeanPreferenzaDiRicerca> ottieniPreferenzeDiRicercaDelTurista(
			int pIdTurista) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle preferenze di ricerca di
			// un Turista
			String query = "SELECT * FROM gradimento,preferenzediricerca WHERE IdTurista = "
					+ pIdTurista
					+ " AND IdPreferenzeDiRicerca = preferenzediricerca.Id ";
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPreferenzaDiRicerca
			ArrayList<BeanPreferenzaDiRicerca> lista = new ArrayList<BeanPreferenzaDiRicerca>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo i BeanPreferenzaDiRicerca alla lista
				lista.add(new BeanPreferenzaDiRicerca(result.getInt("Id"),
						result.getString("Nome")));
			}
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPreferenzaDiRicerca> ottieniPreferenzeDiRicerca()
			throws SQLException
	{
		//Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle preferenze di ricerca di
			// un Turista
			String query = "SELECT * FROM preferenzediricerca ";
			//Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPreferenzaDiRicerca
			ArrayList<BeanPreferenzaDiRicerca> lista = new ArrayList<BeanPreferenzaDiRicerca>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo i BeanPreferenzaDiRicerca alla lista
				lista.add(new BeanPreferenzaDiRicerca(result.getInt("Id"),
						result.getString("Nome")));
			}
			//Restituisco la lista delle preferenze di ricerca presenti nel DB
			return lista;
		}
		//Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}
}
