﻿package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import unisa.gps.etour.bean.BeanPreferenzeGeneriche;

/**
 * Implementazione dell'interfaccia IDBPreferenzeGeneriche
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBPreferenzeGeneriche implements IDBPreferenzeGeneriche
{
	// Costruttore senza parametri
	public DBPreferenzeGeneriche()
	{

	}

	public boolean cancellaPreferenzaGenerica(int pIdPreferenza)
			throws SQLException
	{
		// Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();
			// Query
			String query = "DELETE FROM preferenzegeneriche WHERE Id ="
					+ pIdPreferenza;
			// Si esegue la query
			int i = stat.executeUpdate(query);

			return (i == 1);
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean inserisciPreferenzaGenenerica(
			BeanPreferenzeGeneriche pPreferenza) throws SQLException
	{
		// Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();
			// Query
			String query = "INSERT INTO preferenzegeneriche(IdTurista, Font, Tema, DimensioneFont) "
					+ "VALUES("
					+ pPreferenza.getIdTurista()
					+ ",'"
					+ pPreferenza.getFont()
					+ "','"
					+ pPreferenza.getTema()
					+ "'," + pPreferenza.getDimensioneFont() + ")";
			// Si esegue la query
			int i = stat.executeUpdate(query);
			return (i == 1);
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean modificaPreferenzaGenerica(
			BeanPreferenzeGeneriche pPreferenza) throws SQLException
	{
		// Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();
			// Query
			String query = "UPDATE preferenzegeneriche SET " + "IdTurista = "
					+ pPreferenza.getIdTurista() + ", Font = '"
					+ pPreferenza.getFont() + "', Tema = '"
					+ pPreferenza.getTema() + "', DimensioneFont = "
					+ pPreferenza.getDimensioneFont() + " WHERE Id = "
					+ pPreferenza.getId();
			// Si esegue la query
			int i = stat.executeUpdate(query);

			return (i == 1);
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public BeanPreferenzeGeneriche ottieniPreferenzaGenerica(int pIdTurista)
			throws SQLException
	{
		// Connessione al database
		Connection conn = null;
		// Statement per eseguire le query
		Statement stat = null;
		// Resut set dove verra inserito l'output della query
		ResultSet result = null;
		// Blocco try dove vengono eseguite le query e la connessione al database
		try
		{
			// Si ottiene la connessione al database dal pool
			conn = DBConnessionePool.ottieniConnessione();
			// Si crea lo statement
			stat = conn.createStatement();
			// Query
			String query = "SELECT * FROM preferenzegeneriche WHERE IdTurista = "
					+ pIdTurista;
			// si esegue la query
			result = stat.executeQuery(query);
			BeanPreferenzeGeneriche pref = null;
			// Si controlla che la query restituisca almeno un risultato
			if (result.next())
			{
				pref = new BeanPreferenzeGeneriche();
				pref.setId(result.getInt("Id"));
				pref.setIdTurista(result.getInt("IdTurista"));
				pref.setDimensioneFont(result.getInt("DimensioneFont"));
				pref.setFont(result.getString("Font"));
				pref.setTema(result.getString("Tema"));
			}
			return pref;
		}
		// Blocco finally che contiene le istruzione per chiudere le connessioni
		// iene eseguito in qualsiasi caso
		finally
		{
			// Si chiude il result set solo se e' stata effettuata la query
			if (result != null)
			{
				result.close();
			}
			// Si chiude lo statement se e' stato aperto
			if (stat != null)
			{
				stat.close();
			}
			// Si restituisce la connessione al pool se e' stata aperta
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

}
