package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Time;
import java.util.ArrayList;
import java.util.Date;

import unisa.gps.etour.bean.BeanPuntoDiRistoro;
import unisa.gps.etour.bean.BeanTag;
import unisa.gps.etour.util.Punto3D;

/**
 * Classe che implementa l'interfaccia del Punto di Ristoro
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBPuntoDiRistoro implements IDBPuntoDiRistoro
{
	// Costruttore vuoto
	public DBPuntoDiRistoro()
	{

	}

	public boolean cancellaPuntoDiRistoro(int pIdPuntoDiRistoro)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM puntodiristoro WHERE Id ="
					+ pIdPuntoDiRistoro;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public boolean inserisciPuntoDiRistoro(BeanPuntoDiRistoro pPuntoDiRistoro)
			throws SQLException
	{
		// Creazione dell'Orario di Apertura e Chiusura
		java.sql.Time orarioApertura = new Time(pPuntoDiRistoro
				.getOrarioApertura().getTime());
		java.sql.Time orarioChiusura = new Time(pPuntoDiRistoro
				.getOrarioChiusura().getTime());
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento di un punto di ristoro
			String query = "INSERT INTO puntodiristoro(Nome,"
					+ "Descrizione, Telefono, Latitudine, Longitudine,"
					+ "Altitudine, OrarioApertura, OrarioChiusura, GiornoChiusura,"
					+ "Localita, Citta, Via, Cap, Provincia, MediaVoti, NumeroVoti,"
					+ "PartitaIva) VALUES ('" + pPuntoDiRistoro.getNome()
					+ "','" + pPuntoDiRistoro.getDescrizione() + "','"
					+ pPuntoDiRistoro.getTelefono() + "',"
					+ pPuntoDiRistoro.getPosizione().getLatitudine() + ","
					+ pPuntoDiRistoro.getPosizione().getLongitudine() + ","
					+ pPuntoDiRistoro.getPosizione().getAltitudine() + ",'"
					+ orarioApertura.toString() + "','"
					+ orarioChiusura.toString() + "','"
					+ pPuntoDiRistoro.getGiornoChiusura() + "','"
					+ pPuntoDiRistoro.getLocalita() + "','"
					+ pPuntoDiRistoro.getCitta() + "','"
					+ pPuntoDiRistoro.getVia() + "','"
					+ pPuntoDiRistoro.getCap() + "','"
					+ pPuntoDiRistoro.getProvincia() + "',"
					+ pPuntoDiRistoro.getMediaVoti() + ","
					+ pPuntoDiRistoro.getNumeroVoti() + ",'"
					+ pPuntoDiRistoro.getPartitaIva() + "');";
			// Si esegue la query di inserimento
			int i = stat.executeUpdate(query);
			return (i == 1);
		}
		// Viene sempre eseguito e si occupa di chiudere lo Statement, e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean modificaPuntoDiRistoro(BeanPuntoDiRistoro pPuntoDiRistoro)
			throws SQLException
	{
		// Creazione dell'Orario di Apertura e Chiusura
		java.sql.Time orarioApertura = new Time(pPuntoDiRistoro
				.getOrarioApertura().getTime());
		java.sql.Time orarioChiusura = new Time(pPuntoDiRistoro
				.getOrarioChiusura().getTime());
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di modifica
			String query = "UPDATE puntodiristoro SET " + " Nome = '"
					+ pPuntoDiRistoro.getNome() + "', Descrizione='"
					+ pPuntoDiRistoro.getDescrizione() + "', Telefono= '"
					+ pPuntoDiRistoro.getTelefono() + "', Latitudine= "
					+ pPuntoDiRistoro.getPosizione().getLatitudine()
					+ ", Longitudine= "
					+ pPuntoDiRistoro.getPosizione().getLongitudine()
					+ ", Altitudine="
					+ pPuntoDiRistoro.getPosizione().getAltitudine()
					+ ", OrarioApertura='" + orarioApertura.toString()
					+ "', OrarioChiusura='" + orarioChiusura.toString()
					+ "', GiornoChiusura='"
					+ pPuntoDiRistoro.getGiornoChiusura() + "',Localita= '"
					+ pPuntoDiRistoro.getLocalita() + "', Citta='"
					+ pPuntoDiRistoro.getCitta() + "', Via= '"
					+ pPuntoDiRistoro.getVia() + "', Cap= '"
					+ pPuntoDiRistoro.getCap() + "', Provincia='"
					+ pPuntoDiRistoro.getProvincia() + "', MediaVoti = "
					+ pPuntoDiRistoro.getMediaVoti() + ", NumeroVoti= "
					+ pPuntoDiRistoro.getNumeroVoti() + ", PartitaIva= '"
					+ pPuntoDiRistoro.getPartitaIva() + "' WHERE Id= "
					+ pPuntoDiRistoro.getId();
			// Si esegue la query di Modifica
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene sempre eseguito e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public int ottieniNumeroElementiRicerca(String pKeyword,
			ArrayList<BeanTag> pTags, Punto3D pPosizione,
			double pDistanzaMassima) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per ottenere il numero di pagine
			String query = "";
			if (pTags.size() == 0)
			{
				// Query senza il controllo dei tag
				query = "SELECT count(numero) FROM (SELECT count(puntodiristoro.Id) AS numero "
						+ "FROM puntodiristoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine()
						+ ","
						+ pPosizione.getLongitudine()
						+ ") < "
						+ pDistanzaMassima
						+ "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC) AS tabella ";
			}
			else
			{
				// Query con i tag
				query = "SELECT count(numero) FROM (SELECT count(puntodiristoro.Id) AS numero "
						+ "FROM puntodiristoro "
						+ "JOIN (appartenenzapr JOIN tag ON IdTag = Id) "
						+ "ON puntodiristoro.Id = appartenenzapr.IdPuntoDiRistoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%') AND (tag.Nome = '" + pTags.get(0).getNome();
				if (pTags.size() >= 2)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(1).getNome();
				}
				if (pTags.size() >= 3)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(2).getNome();
				}
				if (pTags.size() >= 4)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(3).getNome();
				}
				if (pTags.size() >= 5)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(4).getNome();
				}
				query = query
						+ "') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC) AS tabella ";

			}
			// Si esegue la query
			result = stat.executeQuery(query);
			// Si restituisce il valore di count() che contiene il numero delle
			// tuple
			int i = 0;
			if (result.next())
			{
				i = result.getInt(1);
			}
			return i;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public int ottieniNumeroElementiRicercaAvanzata(int pIdTurista,
			String pKeyword, ArrayList<BeanTag> pTags, Punto3D pPosizione,
			double pDistanzaMassima) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per ottenere il numero di pagine della ricerca avanzata
			String query = "";
			if (pTags.size() == 0)
			{
				// Query senza il controllo dei tag
				query = "SELECT count(numero) FROM (SELECT count(puntodiristoro.Id) AS numero "
						+ "FROM (puntodiristoro  LEFT JOIN "
						+ "(SELECT IdPuntoDiRistoro "
						+ "FROM associazionepr, ("
						+ "SELECT IdPreferenzeDiRicerca "
						+ "FROM gradimento "
						+ "WHERE IdTurista = "
						+ pIdTurista
						+ " ) AS pref "
						+ "WHERE associazionepr.IdPreferenzeDiRicerca = pref.IdPreferenzeDiRicerca) "
						+ "AS preferenze ON puntodiristoro.Id = preferenze.IdPuntoDiRistoro) "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine()
						+ ","
						+ pPosizione.getLongitudine()
						+ ") < "
						+ pDistanzaMassima
						+ "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC) AS tabella ";
			}
			else
			{
				// Query con i tag
				query = "SELECT count(numero) FROM (SELECT count(puntodiristoro.Id) AS numero "
						+ "FROM (puntodiristoro  LEFT JOIN "
						+ "(SELECT IdPuntoDiRistoro "
						+ "FROM associazionepr, ("
						+ "SELECT IdPreferenzeDiRicerca "
						+ "FROM gradimento "
						+ "WHERE IdTurista = "
						+ pIdTurista
						+ " ) AS pref "
						+ "WHERE associazionepr.IdPreferenzeDiRicerca = pref.IdPreferenzeDiRicerca) "
						+ "AS preferenze ON puntodiristoro.Id = preferenze.IdPuntoDiRistoro) "
						+ "JOIN (appartenenzapr JOIN tag ON IdTag = Id) "
						+ "ON puntodiristoro.Id = appartenenzapr.IdPuntoDiRistoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%') AND (tag.Nome = '" + pTags.get(0).getNome();
				if (pTags.size() >= 2)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(1).getNome();
				}
				if (pTags.size() >= 3)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(2).getNome();
				}
				if (pTags.size() >= 4)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(3).getNome();
				}
				if (pTags.size() >= 5)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(4).getNome();
				}
				query = query
						+ "') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC) AS tabella ";
			}
			// Si esegue la query
			result = stat.executeQuery(query);
			// Si restituisce il valore di count() che contiene il numero delle
			// tuple
			int i = 0;
			if (result.next())
			{
				i = result.getInt(1);
			}
			return i;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public BeanPuntoDiRistoro ottieniPuntoDiRistoro(int pId)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query
			String query = "SELECT * FROM puntodiristoro WHERE Id =" + pId;
			// Si esegue la query
			result = stat.executeQuery(query);
			if (result.next())
			{
				// Si generano gli oggetti da restituire
				Punto3D punto = new Punto3D(result.getDouble("Latitudine"),
						result.getDouble("Longitudine"), result
								.getDouble("Altitudine"));
				Date orarioApertura = new Date(result.getTime("OrarioApertura")
						.getTime());
				Date orarioChiusura = new Date(result.getTime("OrarioChiusura")
						.getTime());
				// Si genera il bean del punto di ristoro
				BeanPuntoDiRistoro puntoTemp = new BeanPuntoDiRistoro(result
						.getInt("Id"), result.getInt("NumeroVoti"), result
						.getDouble("MediaVoti"), result.getString("Nome"),
						result.getString("Descrizione"), result
								.getString("Telefono"), result
								.getString("Localita"), result
								.getString("Citta"), result.getString("Via"),
						result.getString("Cap"), result.getString("Provincia"),
						result.getString("PartitaIva"), punto, orarioApertura,
						orarioChiusura, result.getString("GiornoChiusura"));
				// Si restituisce il punto di ristoro
				return puntoTemp;
			}
			else
			{
				return null;
			}
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPuntoDiRistoro> ricerca(String pKeyword,
			ArrayList<BeanTag> pTags, int pNumeroPagina,
			int pNumeroElementiPerPagina, Punto3D pPosizione,
			double pDistanzaMassima) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per la ricerca
			String query = "";
			if (pTags.size() == 0)
			{
				// Query senza il controllo dei tag
				query = "SELECT * "
						+ "FROM puntodiristoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC LIMIT "
						+ (pNumeroPagina * pNumeroElementiPerPagina) + ","
						+ pNumeroElementiPerPagina;
			}
			else
			{
				// Query con i tag
				query = "SELECT * "
						+ "FROM puntodiristoro "
						+ "JOIN (appartenenzapr JOIN tag ON IdTag = Id) "
						+ "ON puntodiristoro.Id = appartenenzapr.IdPuntoDiRistoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%" + pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%" + pKeyword
						+ "%') AND (tag.Nome = '" + pTags.get(0).getNome();
				if (pTags.size() >= 2)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(1).getNome();
				}
				if (pTags.size() >= 3)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(2).getNome();
				}
				if (pTags.size() >= 4)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(3).getNome();
				}
				if (pTags.size() >= 5)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(4).getNome();
				}
				query = query
						+ "') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC LIMIT "
						+ (pNumeroPagina * pNumeroElementiPerPagina) + ","
						+ pNumeroElementiPerPagina;
			}
			// Si esegue la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPuntoDiRistoro
			ArrayList<BeanPuntoDiRistoro> lista = new ArrayList<BeanPuntoDiRistoro>();
			while (result.next())
			{
				// Si generano gli oggetti da restituire
				Punto3D punto = new Punto3D(result.getDouble("Latitudine"),
						result.getDouble("Longitudine"), result
								.getDouble("Altitudine"));
				Date orarioApertura = new Date(result.getTime("OrarioApertura")
						.getTime());
				Date orarioChiusura = new Date(result.getTime("OrarioChiusura")
						.getTime());
				// Si genera il punto di ristoro
				BeanPuntoDiRistoro puntoTemp = new BeanPuntoDiRistoro(result
						.getInt("Id"), result.getInt("NumeroVoti"), result
						.getDouble("MediaVoti"), result.getString("Nome"),
						result.getString("Descrizione"), result
								.getString("Telefono"), result
								.getString("Localita"), result
								.getString("Citta"), result.getString("Via"),
						result.getString("Cap"), result.getString("Provincia"),
						result.getString("PartitaIva"), punto, orarioApertura,
						orarioChiusura, result.getString("GiornoChiusura"));
				// Si inserisce il bean nella lista
				lista.add(puntoTemp);
			}
			// Si restituisce la lista
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPuntoDiRistoro> ricercaAvanzata(int pIdTurista,
			String pKeyword, ArrayList<BeanTag> pTags, int pNumeroPagina,
			int pNumeroElementiPerPagina, Punto3D pPosizione,
			double pDistanzaMassima) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per la ricerca avanzata
			String query = "";
			if (pTags.size() == 0)
			{
				// Query senza i tag
				query = "SELECT * "
						+ "FROM (puntodiristoro  LEFT JOIN "
						+ "(SELECT IdPuntoDiRistoro "
						+ "FROM associazionepr, ("
						+ "SELECT IdPreferenzeDiRicerca "
						+ "FROM gradimento "
						+ "WHERE IdTurista = "
						+ pIdTurista
						+ " ) AS pref "
						+ "WHERE associazionepr.IdPreferenzeDiRicerca = pref.IdPreferenzeDiRicerca) "
						+ "AS preferenze ON puntodiristoro.Id = preferenze.IdPuntoDiRistoro) "
						+ "WHERE (puntodiristoro.Nome LIKE '%"
						+ pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%"
						+ pKeyword
						+ "%')"
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC LIMIT "
						+ (pNumeroPagina * pNumeroElementiPerPagina) + ","
						+ pNumeroElementiPerPagina;
			}
			else
			{
				// Query con i tag
				query = "SELECT * "
						+ "FROM (puntodiristoro  LEFT JOIN "
						+ "(SELECT IdPuntoDiRistoro "
						+ "FROM associazionepr, ("
						+ "SELECT IdPreferenzeDiRicerca "
						+ "FROM gradimento "
						+ "WHERE IdTurista = "
						+ pIdTurista
						+ " ) AS pref "
						+ "WHERE associazionepr.IdPreferenzeDiRicerca = pref.IdPreferenzeDiRicerca) "
						+ "AS preferenze ON puntodiristoro.Id = preferenze.IdPuntoDiRistoro) "
						+ "JOIN (appartenenzapr JOIN tag ON IdTag = Id) "
						+ "ON puntodiristoro.Id = appartenenzapr.IdPuntoDiRistoro "
						+ "WHERE (puntodiristoro.Nome LIKE '%" + pKeyword
						+ "%' OR puntodiristoro.Descrizione LIKE '%" + pKeyword
						+ "%') AND (tag.Nome = '" + pTags.get(0).getNome();
				if (pTags.size() >= 2)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(1).getNome();
				}
				if (pTags.size() >= 3)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(2).getNome();
				}
				if (pTags.size() >= 4)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(3).getNome();
				}
				if (pTags.size() >= 5)
				{
					query = query + "' OR tag.Nome = '"
							+ pTags.get(4).getNome();
				}
				query = query
						+ "') "
						+ " AND distanza(puntodiristoro.Latitudine,puntodiristoro.Longitudine,"
						+ pPosizione.getLatitudine() + ","
						+ pPosizione.getLongitudine() + ") < "
						+ pDistanzaMassima + "GROUP BY puntodiristoro.Id "
						+ "ORDER BY count(puntodiristoro.Id) DESC LIMIT "
						+ (pNumeroPagina * pNumeroElementiPerPagina) + ","
						+ pNumeroElementiPerPagina;
			}
			// Si esegue la query
			result = stat.executeQuery(query);

			ArrayList<BeanPuntoDiRistoro> lista = new ArrayList<BeanPuntoDiRistoro>();
			while (result.next())
			{
				// Si generano gli oggetti da restituire
				Punto3D punto = new Punto3D(result.getDouble("Latitudine"),
						result.getDouble("Longitudine"), result
								.getDouble("Altitudine"));
				Date orarioApertura = new Date(result.getTime("OrarioApertura")
						.getTime());
				Date orarioChiusura = new Date(result.getTime("OrarioChiusura")
						.getTime());
				// Si genera il bene culturale
				BeanPuntoDiRistoro beneTemp = new BeanPuntoDiRistoro(result
						.getInt("Id"), result.getInt("NumeroVoti"), result
						.getDouble("MediaVoti"), result.getString("Nome"),
						result.getString("Descrizione"), result
								.getString("Telefono"), result
								.getString("Localita"), result
								.getString("Citta"), result.getString("Via"),
						result.getString("Cap"), result.getString("Provincia"),
						result.getString("PartitaIva"), punto, orarioApertura,
						orarioChiusura, result.getString("GiornoChiusura"));
				// Si inserisce il bean nella lista
				lista.add(beneTemp);
			}
			// Si restituisce la lista
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPuntoDiRistoro> ottieniListaPR() throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per ottenere la lista di tutti i punti di ristoro
			String query = "SELECT * FROM puntodiristoro";
			// Si esegue la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanPuntoDiRistoro
			ArrayList<BeanPuntoDiRistoro> lista = new ArrayList<BeanPuntoDiRistoro>();
			while (result.next())
			{
				// Si generano gli oggetti da restituire
				Punto3D punto = new Punto3D(result.getDouble("Latitudine"),
						result.getDouble("Longitudine"), result
								.getDouble("Altitudine"));
				Date orarioApertura = new Date(result.getTime("OrarioApertura")
						.getTime());
				Date orarioChiusura = new Date(result.getTime("OrarioChiusura")
						.getTime());
				// Si genera il punto di ristoro
				BeanPuntoDiRistoro puntoTemp = new BeanPuntoDiRistoro(result
						.getInt("Id"), result.getInt("NumeroVoti"), result
						.getDouble("MediaVoti"), result.getString("Nome"),
						result.getString("Descrizione"), result
								.getString("Telefono"), result
								.getString("Localita"), result
								.getString("Citta"), result.getString("Via"),
						result.getString("Cap"), result.getString("Provincia"),
						result.getString("PartitaIva"), punto, orarioApertura,
						orarioChiusura, result.getString("GiornoChiusura"));
				// Si inserisce il bean nella lista
				lista.add(puntoTemp);
			}
			// Si restituisce la lista
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

}
