package unisa.gps.etour.control.GestioneUtentiRegistrati;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interfaccia relativa alle operazioni di LogIn e LogOut effettuate dall'Utente
 * Registrato
 * 
 * @author Penna Giuseppe
 * @version 0.1 2007 eTour Project - Copyright by SE@SA Lab DMI University of
 *          Salerno
 */
public interface IAutenticazione extends Remote
{

	// Costanti statiche che identificano la tipologia di Utente che si
	// autentica
	public static final byte TURISTA = 0;
	public static final byte OP_PUNTO_DI_RISTORO = 1;
	
	/**
	 * Metodo per l'autenticazione di un Utente Registrato(Turista - Operatore
	 * Punto di Ristoro)
	 * 
	 * @param pUserName Nome Utente relativo all'Utente Registrato
	 * @param pPassword Password relativa all'Utente Registrato
	 * @param pTipologiaUtente Tipologia dell'utente che si autentica
	 * @return Se i dati sono corretti l'Id dell'utente loggato, in caso
	 *         contrario -1
	 */
	public int login(String pUsername, String pPassword, byte pTipologiaUtente)
			throws RemoteException;

}
