package unisa.gps.etour.repository;

import java.sql.SQLException;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanMenu;


/**
 * Interfaccia per la gestione dei menu nel database
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBMenu
{
	/**
	 * Aggiunge un menu nel database
	 * 
	 * @param pMenu Menu da aggiungere
	 * @throws SQLException
	 */
	public boolean inserisciMenu(BeanMenu pMenu) throws SQLException;

	/**
	 * Modifica un menu nel database
	 * 
	 * @param pMenu Contiene i dati da modificare
	 * @throws SQLException
	 * @return True se c'e' stata una modifica false altrimenti
	 */
	public boolean modificaMenu(BeanMenu pMenu) throws SQLException;

	/**
	 * Elimina un menu dal database
	 * 
	 * @param pIdMenu Identificativo Menu da eliminare
	 * @throws SQLException
	 * @return True se e' stato cancellato false altrimenti
	 */
	public boolean cancellaMenu(int pIdMenu) throws SQLException;

	/**
	 * Restituisce il menu del giorno di un punto di ristoro
	 * 
	 * @param pIdPuntoDiRistoro Identificativo del punto di ristoro
	 * @param pGiorno Giorno della settimana a cui si riferisce il menu
	 *            giornaliero
	 * @throws SQLException
	 * @return Menu del giorno de Punto di ristoro
	 */
	public BeanMenu ottieniMenuDelGiorno(int pIdPuntoDiRistoro, String pGiorno)
			throws SQLException;

	/**
	 * Restituisce la lista dei menu di un punto di ristoro
	 * 
	 * @param pIdPuntoDiRistoro Identificativo del Punto di Ristoro
	 * @throws SQLException
	 * @return Lista dei menu
	 */
	public ArrayList<BeanMenu> ottieniMenu(int pIdPuntoDiRistoro)
			throws SQLException;
}
