﻿package unisa.gps.etour.repository;

import java.sql.SQLException;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanNews;

/**
 * Interfaccia per la gestione delle news nel Database
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBNews
{
	/**
	 * Aggiunge una news nel database
	 * 
	 * @param pNews News da aggiungere
	 * @throws SQLException
	 */
	public boolean inserisciNews(BeanNews pNews) throws SQLException;

	/**
	 * Modifica una news nel database
	 * 
	 * @param pNews News da modificare con i dati nuovi
	 * @throws SQLException
	 * @return True se c'e' stata una modifica false altrimenti
	 */
	public boolean modificaNews(BeanNews pNews) throws SQLException;

	/**
	 * Elimina una news dal database
	 * 
	 * @param pIdNews Identificativo News da eliminare
	 * @throws SQLException
	 * @return True se e' stata cancellata false altrimenti
	 */
	public boolean cancellaNews(int pIdNews) throws SQLException;

	/**
	 * Restituisce le news attive
	 * 
	 * @throws SQLException
	 * @return Liste di news attive
	 */
	public ArrayList<BeanNews> ottieniNews() throws SQLException;
}
