package unisa.gps.etour.control.GestioneAdvertisement;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.HashMap;

import javax.swing.ImageIcon;

import unisa.gps.etour.bean.BeanBanner;

/**
 * Interfaccia generale di Gestione dei Banner e della news.
 *
 * @author Palladino Fabio
 * @version 0.1
 * 
 * � 2007 eTour Project - Copyright by SE@SA Lab DMI University of Salerno
 */
public interface IGestioneAdvertisement extends Remote
{
	/**
	 * Inserisce un nuovo banner.
	 * 
	 * @param pBanner Bean contenente i dati del banner
	 * @throws RemoteException
	 */
	public boolean inserisciBanner(int pIdPuntoDiRistoro,ImageIcon pImmagineBanner) 
		throws RemoteException;
	/**
	 * Elimina un Banner dal sistema.
	 * 
	 * @param pBannerID ID del banner da cancellare.
	 * @return true se l'operazione va a buon fine false altrimenti.
	 * @throws RemoteException
	 */
	public boolean cancellaBanner(int pBannerID) throws RemoteException;
	/**
	 * Modifica i dati del banner o l'immagine associata.
	 * 
	 * @param pBanner Bean contenente i dati del banner.
	 * @return true se l'operazione va a buon fine, false altrimenti.
	 * @throws RemoteException
	 */
	public boolean modificaBanner(int pBannerID,ImageIcon pImmagine) 
		throws RemoteException;
	/**
	 * Restituisce una lista di Banner di un determinato punto di ristoro.
	 * 
	 * @param pPuntoDiRistoroID Id del punto di ristoro proprietario dei banner
	 * @return ArrayList Lista contenete i banner del punto di ristoro
	 * @throws RemoteException
	 */
	public HashMap<BeanBanner,ImageIcon> ottieniBannersDaID(int pIdPuntoDiRistoro)
		throws RemoteException;
	
}
