package unisa.gps.etour.control.GestioneTag;

import java.rmi.RemoteException;

import unisa.gps.etour.bean.BeanTag;

/**
 * Interfaccia per la gestione dei Tag da parte dell'Operatore Agenzia
 * 
 * @author Morelli Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IGestioneTagOperatoreAgenzia extends IGestioneTagComune
{

	/**
	 * Metodo per l'inserimento di un nuovo Tag
	 * 
	 * @param pTagNuovo contenente tutti i dati del nuovo Tag
	 * @return Booleano: true se l'operazione va a buon fine, false altrimenti
	 * @throws RemoteException Eccezione Remota
	 */
	public boolean inserisciTag(BeanTag pTagNuovo) throws RemoteException;

	/**
	 * Metodo per la cancellazione di un Tag esistente
	 * 
	 * @param pTagID per l'identificazione del Tag in questione
	 * @return Booleano: true se l'operazione va a buon fine, false altrimenti
	 * @throws RemoteException Eccezione Remota
	 */
	public boolean cancellaTag(int pTagID) throws RemoteException;

	/**
	 * Metodo per la modifica di un Tag
	 * 
	 * @param pTagModificato contenente i dati nuovi del Tag
	 * @return Booleano: true se l'operazione va a buon fine, false altrimenti
	 * @throws RemoteException Eccezione Remota
	 */
	public boolean modificaTag(BeanTag pTagModificato) throws RemoteException;

	/**
	 * Metodo che restituisce un Tag identificato dal suo ID
	 * 
	 * @param pTagID per identificare un particolare Tag
	 * @return un BeanTag contenente i dati del Tag interessato
	 * @throws RemoteException Eccezione Remota
	 */
	public BeanTag ottieniTag(int pTagID) throws RemoteException;

}
