/*
* SchedaPR.java
*
* 1.0
*
* 28/05/2007
*
*  2007 eTour Project - Copyright by SE@SA Lab - DMI  University of Salerno
*/

package unisa.gps.etour.gui.operatoreagenzia;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JInternalFrame;
import javax.swing.ImageIcon;
import javax.swing.WindowConstants;
import java.awt.Dimension;
import javax.swing.JTabbedPane;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import java.awt.Color;
import java.awt.Component;
import java.awt.Insets;
import java.awt.Rectangle;
import javax.swing.JToolBar;
import javax.swing.JToggleButton;
import javax.swing.JButton;
import java.awt.Font;
import java.awt.Cursor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.StringTokenizer;

import javax.swing.JComboBox.KeySelectionManager;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import unisa.gps.etour.bean.*;
import unisa.gps.etour.bean.util.Punto3D;
/**
 * Classe che modella l'interfaccia per la visualizzazione della scheda, 
 * la modifica dei dati e l'inserimento di un nuovo punto di ristoro.
 * 
 * @author Lello
 *
 */
public class SchedaPR extends JInternalFrame {

	private JPanel jContentPane = null;
	private JToolBar toolbarSchedaBC = null;
	private JToggleButton btnModifica = null;
	private JButton btnSalva = null;
	private JButton btnAnnulla = null;
	private JButton btnModificaCommento = null;
	private JTabbedPane jTabbedPane = null;
	private JPanel statistiche = null;
	private JPanel feedback = null;
	private JLabel txtNome = null;
	private JLabel txtIndirizzo = null;
	private JLabel txtCAP = null;
	private JLabel txtCitta = null;
	private JLabel txtLocalit = null;
	private JLabel txtProvincia = null;
	private JLabel txtPos = null;
	private JLabel txtTel = null;
	private JLabel txtOraAp = null;
	private JLabel txtOraCh = null;

	private JLabel jLabel = null;
	private JTextField indirizzoPR = null;
	private JComboBox indirizzoPR1 = null;
	private JTextField cittaPR = null;
	private JComboBox localitaPR = null;
	private JTextField capPR = null;
	private JScrollPane jScrollPane = null;
	private JTextArea descrizionePR = null;
	private JTextField telefonoPR = null;
	private JComboBox orarioAPOrePR = null;
	private JLabel jLabel1 = null;
	private JComboBox orarioApMinPR = null;
	private TagPanel pannelloTag;
	private JTextField costoBC = null;
	
	private JLabel jLabel3 = null;
	private JComboBox orarioCHMinPR = null;
	private JComboBox provPR = null;
	private JPanel datiPR = null;
	private JTextField nomePR = null;
	private JPanel jPanel = null;
	private JScrollPane jScrollPane2 = null;
	private JTable feedbackTable = null;
	private JLabel txtNomeBene = null;
	private JLabel mediaVotoPR = null;
	private JPanel statisticheMeseCorrente = null;
	private JPanel statisticheTotali = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel41 = null;
	private ActionListener campoCompilato;
	private FocusListener validating;
	private JToolBar ToolbarSchedaPR = null;
	private JTextField posGeoX = null;
	private JTextField posGeoY = null;
	private JTextField posGeoZ = null;
	private JLabel jLabel2 = null;
	private JComboBox orarioCHOrePR = null;
	/**
	 * Il costruttore di default modella l'interfaccia relativa all'inserimento di
	 * un nuovo punto di ristoro.
	 * 
	 */
	public SchedaPR() 
	{
		super("Nuovo Punto di Ristoro");
		campoCompilato = new ActionListener() {

			public void actionPerformed(ActionEvent actionEvent) 
			{
				((JComponent)actionEvent.getSource()).transferFocus();
			}
			
		};
		validating = new FocusListener() {

		    private final Color ERROR_BACKGROUND = new Color(255, 215, 215);
		    private final Color WARNING_BACKGROUND = new Color(255, 235, 205);
			private String text;
			
			public void focusGained(FocusEvent fe) {
				if (fe.getSource() instanceof JTextField) {
					JTextField textbox = (JTextField) fe.getSource();
					text = textbox.getText();
				}
				
			}

			public void focusLost(FocusEvent fe) {
				if (fe.getSource() instanceof JTextField) {
					JTextField textbox = (JTextField) fe.getSource();
					if (!text.equals(textbox.getText())) {
						text = textbox.getText();
						if (text.equals("")) {
							textbox.setBackground(ERROR_BACKGROUND);
							Rectangle bounds = textbox.getBounds();
							JLabel nuova = new JLabel();
							nuova.setIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/images/error.png")));
							nuova.setBounds(bounds.x-24,bounds.y,24,24);
							nuova.setToolTipText("Il campo " + textbox.getName() + " non pu essere vuoto!");
							datiPR.add(nuova,null);
							datiPR.repaint();
						}
					}
				}
				
			}
			
		};
		initialize();
	}
	/**
	 * Questo costruttore modella le interfacce relative alla modifica dei dati e alla
	 * visualizzazione della scheda di un punto di ristoro.
	 * @param unisa.gps.etour.bean.BeanPuntoDiRistoro PR - il bean contenente i dati del 
	 * PuntoDiRistoro selezionato.
	 * @param boolean modifica - indica se i campi devono essere editabili, e quindi se
	 * si sta visualizzando una scheda o modificando i dati del bene culturale.
	 * 
	 */
	public SchedaPR(BeanPuntoDiRistoro pr, boolean modifica) 
	{
		this();

		nomePR.setText(pr.getNome());
		setTitle(pr.getNome());
		capPR.setText(pr.getCap());
		cittaPR.setText(pr.getCitta());
		
		descrizionePR.setText(pr.getDescrizione());
		StringTokenizer tokenizer = new StringTokenizer(pr.getVia());
		/*
		 * 			indirizzoPR1.addItem("Via");
			indirizzoPR1.addItem("P.zza");
			indirizzoPR1.addItem("V.le");
			indirizzoPR1.addItem("V.co");
			indirizzoPR1.addItem("Largo");
			indirizzoPR1.addItem("Corso");
		 */
		String[] via = {"Via","P.zza","V.le","V.co","Largo","Corso"};
		String stringa = tokenizer.nextToken();
		int i;
		for (i = 0; i < via.length; i++)
			if (stringa.equalsIgnoreCase(via[i]))
				break;
		this.indirizzoPR1.setSelectedIndex(i);
		while (tokenizer.hasMoreTokens())
			this.indirizzoPR.setText(indirizzoPR.getText() + " " + tokenizer.nextToken());
		this.provPR.setSelectedItem(pr.getProvincia());
		Punto3D pos = pr.getPosizione();
		this.posGeoX.setText(""+pos.getX());
		this.posGeoY.setText(""+pos.getY());
		this.posGeoZ.setText(""+pos.getZ());
		this.telefonoPR.setText(pr.getTelefono());
		int minuti = pr.getOrarioApertura().getMinutes();
		if (minuti==0)
			this.orarioApMinPR.setSelectedIndex(0);
		else
			this.orarioApMinPR.setSelectedItem(minuti);
		int ore = pr.getOrarioApertura().getHours();
		if (ore<10)
			this.orarioAPOrePR.setSelectedItem("0"+ore);
		else
			this.orarioAPOrePR.setSelectedItem(ore);
		this.orarioCHMinPR.setSelectedItem(pr.getOrarioChiusura().getMinutes());
		this.orarioAPOrePR.setSelectedItem(pr.getOrarioApertura().getHours());
		this.orarioCHOrePR.setSelectedItem(pr.getOrarioChiusura().getHours());	
		if (modifica) {
			btnModifica.setSelected(true);
		}
		else {
			makeEditabled();
		}

	}
	/**
	 * Metodo chiamato dal costruttore
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setIconifiable(true);
		this.setBounds(new Rectangle(0, 0, 600, 540));
		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.setFrameIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/scheda.png")));
		this.setClosable(true);
		this.setContentPane(getJContentPane());
	}

	private void makeEditabled() 
	{
		Component[] componenti = datiPR.getComponents();
		for(int i = 0; i < componenti.length; i++) {
			Component corrente = componenti[i];
			if (corrente instanceof JTextField) 
			{
				JTextField textbox = (JTextField) corrente;
				textbox.setEditable(textbox.isEditable() ? false : true);
				textbox.setBackground(Color.white);
				
			}
			else if (corrente instanceof JComboBox) 
			{
				JComboBox combobox = (JComboBox) corrente;
				combobox.setEnabled(combobox.isEnabled() ? false : true);
				
			}
		}
		descrizionePR.setEditable(descrizionePR.isEditable()? false: true);
		pannelloTag.attivaDisattiva();
	}
	
	
	/**
	 * Metodo che inizializza un jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			
			jContentPane.add(getJTabbedPane(), BorderLayout.CENTER);
			jContentPane.add(getToolbarSchedaPR(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * questo metodo inizializza il pulsante (ToggleButton) di modifica
	 * dei dati per un puntoDiRistoro
	 * 	
	 * @return javax.swing.JToggleButton	
	 */
	private JToggleButton getBtnModifica() {
		if (btnModifica == null) {
			btnModifica = new JToggleButton();
			btnModifica.setText("Modifica Dati");
			btnModifica.setIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/modifica.png")));
			btnModifica.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent arg0) {
					makeEditabled();
					btnSalva.setVisible((btnModifica.isSelected() ? true : false));
					btnAnnulla.setVisible((btnModifica.isSelected() ? true : false));
									
					
				}
				
			});
		}
		return btnModifica;
	}

	/**
	 * Metodo per inizializzare il pulsante salva (btnSalva)	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnSalva() {
		if (btnSalva == null) {
			btnSalva = new JButton();
			btnSalva.setText("Salva");
			btnSalva.setIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/salva.png")));
			btnSalva.setVisible(false);
		}
		return btnSalva;
	}

	/**
	 * Metodo per inizializzare il pulsante Annulla (btnAnnulla)	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnAnnulla() {
		if (btnAnnulla == null) {
			btnAnnulla = new JButton();
			btnAnnulla.setText("Annulla");
			btnAnnulla.setIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/annulla.png")));
			btnAnnulla.setVisible(false);
		}
		return btnAnnulla;
	}

	/**
	 * Metodo per inizializzare il pulsante per la
	 * modifica di un commento  (btnModificaCommento)	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnModificaCommento() {
		if (btnModificaCommento == null) {
			btnModificaCommento = new JButton();
			btnModificaCommento.setText("Modifica Commento");
			btnModificaCommento.setIcon(new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/modificaCommento.png")));
			btnModificaCommento.setVisible(false);
		}
		return btnModificaCommento;
	}

	/**
	 * Crea ed inizializza una jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			jTabbedPane.addTab("Dati Punto di Ristoro", new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/dati.png")), getDatiPR(), null);
			jTabbedPane.addTab("MenuTuristico", new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/stat24.png")), null, null);
			jTabbedPane.addTab("Statistiche", new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/stat24.png")), getStatistiche(), null);
			jTabbedPane.addTab("Feedback Ricevuti", new ImageIcon(getClass().getResource("/unisa/gps/etour/gui/operatoreagenzia/images/feedback.png")), getFeedback(), null);
			
		}
		return jTabbedPane;
	}
	/**
	 * Metodo per inizializzare un pannello (datiPR)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getDatiPR() {
		if (datiPR == null) {
			GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
			gridBagConstraints27.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints27.gridy = 9;
			gridBagConstraints27.weightx = 1.0;
			gridBagConstraints27.anchor = GridBagConstraints.WEST;
			gridBagConstraints27.insets = new Insets(5, 5, 36, 0);
			gridBagConstraints27.ipadx = 18;
			gridBagConstraints27.gridx = 1;
			GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
			gridBagConstraints34.gridx = 7;
			gridBagConstraints34.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints34.gridy = 6;
			jLabel2 = new JLabel();
			jLabel2.setText("z");
			GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
			gridBagConstraints33.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints33.gridy = 6;
			gridBagConstraints33.weightx = 1.0;
			gridBagConstraints33.ipadx = 50;
			gridBagConstraints33.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints33.anchor = GridBagConstraints.WEST;
			gridBagConstraints33.gridx = 6;
			GridBagConstraints gridBagConstraints38 = new GridBagConstraints();
			gridBagConstraints38.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints38.gridy = 6;
			gridBagConstraints38.weightx = 1.0;
			gridBagConstraints38.ipadx = 50;
			gridBagConstraints38.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints38.anchor = GridBagConstraints.WEST;
			gridBagConstraints38.gridx = 4;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints22.gridy = 6;
			gridBagConstraints22.weightx = 0.0;
			gridBagConstraints22.ipadx = 50;
			gridBagConstraints22.anchor = GridBagConstraints.WEST;
			gridBagConstraints22.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints22.gridx = 1;
			GridBagConstraints gridBagConstraints36 = new GridBagConstraints();
			gridBagConstraints36.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints36.gridy = 6;
			gridBagConstraints36.ipadx = 0;
			gridBagConstraints36.ipady = 0;
			gridBagConstraints36.gridwidth = 1;
			gridBagConstraints36.gridx = 5;
			GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
			gridBagConstraints35.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints35.gridy = 6;
			gridBagConstraints35.ipadx = 0;
			gridBagConstraints35.ipady = 0;
			gridBagConstraints35.gridwidth = 1;
			gridBagConstraints35.anchor = GridBagConstraints.WEST;
			gridBagConstraints35.gridx = 3;
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.insets = new Insets(15, 20, 5, 0);
			gridBagConstraints32.gridx = 16;
			gridBagConstraints32.gridy = 4;
			gridBagConstraints32.ipadx = 172;
			gridBagConstraints32.ipady = 125;
			gridBagConstraints32.gridwidth = 0;
			gridBagConstraints32.gridheight = 6;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints31.gridwidth = 9;
			gridBagConstraints31.gridx = 1;
			gridBagConstraints31.gridy = 0;
			gridBagConstraints31.weightx = 0.0;
			gridBagConstraints31.ipadx = 240;
			gridBagConstraints31.anchor = GridBagConstraints.WEST;
			gridBagConstraints31.insets = new Insets(20, 5, 5, 0);
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			gridBagConstraints30.fill = GridBagConstraints.BOTH;
			gridBagConstraints30.gridwidth = 17;
			gridBagConstraints30.gridx = 1;
			gridBagConstraints30.gridy = 10;
			gridBagConstraints30.ipadx = 265;
			gridBagConstraints30.ipady = 70;
			gridBagConstraints30.weightx = 1.0;
			gridBagConstraints30.weighty = 1.0;
			gridBagConstraints30.gridheight = 4;
			gridBagConstraints30.anchor = GridBagConstraints.WEST;
			gridBagConstraints30.insets = new Insets(5, 5, 2, 5);
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			gridBagConstraints29.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints29.gridwidth = 3;
			gridBagConstraints29.gridx = 4;
			gridBagConstraints29.gridy = 9;
			gridBagConstraints29.weightx = 1.0;
			gridBagConstraints29.ipadx = 18;
			gridBagConstraints29.anchor = GridBagConstraints.WEST;
			gridBagConstraints29.insets = new Insets(5, 5, 36, 2);
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			gridBagConstraints28.insets = new Insets(3, 5, 34, 4);
			gridBagConstraints28.gridy = 9;
			gridBagConstraints28.gridx = 3;
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints26.gridwidth = 3;
			gridBagConstraints26.gridx = 4;
			gridBagConstraints26.gridy = 8;
			gridBagConstraints26.weightx = 1.0;
			gridBagConstraints26.anchor = GridBagConstraints.WEST;
			gridBagConstraints26.ipadx = 18;
			gridBagConstraints26.insets = new Insets(6, 5, 4, 2);
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.insets = new Insets(4, 5, 2, 4);
			gridBagConstraints25.gridy = 8;
			gridBagConstraints25.anchor = GridBagConstraints.WEST;
			gridBagConstraints25.gridx = 3;
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints24.gridx = 1;
			gridBagConstraints24.gridy = 8;
			gridBagConstraints24.weightx = 1.0;
			gridBagConstraints24.ipadx = 18;
			gridBagConstraints24.gridwidth = 3;
			gridBagConstraints24.anchor = GridBagConstraints.WEST;
			gridBagConstraints24.insets = new Insets(6, 5, 4, 1);
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints23.gridwidth = 9;
			gridBagConstraints23.gridx = 1;
			gridBagConstraints23.gridy = 7;
			gridBagConstraints23.weightx = 1.0;
			gridBagConstraints23.ipadx = 120;
			gridBagConstraints23.anchor = GridBagConstraints.WEST;
			gridBagConstraints23.insets = new Insets(4, 5, 4, 17);
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints21.gridwidth = 7;
			gridBagConstraints21.gridx = 1;
			gridBagConstraints21.gridy = 5;
			gridBagConstraints21.ipadx = 70;
			gridBagConstraints21.ipady = 0;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.insets = new Insets(5, 5, 5, 6);
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints20.gridwidth = 7;
			gridBagConstraints20.gridx = 1;
			gridBagConstraints20.gridy = 4;
			gridBagConstraints20.weightx = 1.0;
			gridBagConstraints20.ipadx = 60;
			gridBagConstraints20.anchor = GridBagConstraints.WEST;
			gridBagConstraints20.insets = new Insets(0, 5, 0, 0);
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints19.gridwidth = 4;
			gridBagConstraints19.gridx = 1;
			gridBagConstraints19.gridy = 3;
			gridBagConstraints19.weightx = 1.0;
			gridBagConstraints19.ipadx = 20;
			gridBagConstraints19.anchor = GridBagConstraints.WEST;
			gridBagConstraints19.insets = new Insets(6, 5, 5, 18);
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints18.gridwidth = 6;
			gridBagConstraints18.gridx = 1;
			gridBagConstraints18.gridy = 2;
			gridBagConstraints18.weightx = 1.0;
			gridBagConstraints18.ipadx = 100;
			gridBagConstraints18.anchor = GridBagConstraints.WEST;
			gridBagConstraints18.insets = new Insets(0, 5, 0, 0);
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints17.gridwidth = 9;
			gridBagConstraints17.gridx = 2;
			gridBagConstraints17.gridy = 1;
			gridBagConstraints17.weightx = 1.0;
			gridBagConstraints17.ipadx = 200;
			gridBagConstraints17.anchor = GridBagConstraints.WEST;
			gridBagConstraints17.insets = new Insets(5, 5, 5, 0);
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints16.gridwidth = 3;
			gridBagConstraints16.gridx = 1;
			gridBagConstraints16.gridy = 1;
			gridBagConstraints16.weightx = 1.0;
			gridBagConstraints16.anchor = GridBagConstraints.WEST;
			gridBagConstraints16.ipadx = 0;
			gridBagConstraints16.insets = new Insets(5, 5, 5, 0);
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints15.gridy = 10;
			gridBagConstraints15.gridwidth = 1;
			gridBagConstraints15.gridheight = 0;
			gridBagConstraints15.gridx = 0;
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.insets = new Insets(5, 15, 36, 0);
			gridBagConstraints14.gridy = 9;
			gridBagConstraints14.gridx = 0;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints13.gridy = 8;
			gridBagConstraints13.gridx = 0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints12.gridy = 7;
			gridBagConstraints12.gridx = 0;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints11.gridy = 6;
			gridBagConstraints11.gridx = 0;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints10.gridy = 5;
			gridBagConstraints10.gridx = 0;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints9.gridy = 4;
			gridBagConstraints9.gridx = 0;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints8.gridy = 3;
			gridBagConstraints8.gridx = 0;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints7.gridy = 2;
			gridBagConstraints7.gridx = 0;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new Insets(5, 15, 5, 0);
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.gridx = 0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(20, 15, 5, 0);
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.gridwidth = 1;
			gridBagConstraints5.gridx = 0;
			jLabel41 = new JLabel();
			jLabel41.setFont(new Font("Dialog", Font.BOLD, 14));
			jLabel41.setText("y");
			jLabel4 = new JLabel();
			jLabel4.setFont(new Font("Dialog", Font.BOLD, 14));
			jLabel4.setText("x");
			jLabel3 = new JLabel();
			jLabel3.setFont(new Font("Dialog", Font.BOLD, 18));
			jLabel3.setText(":");

			jLabel1 = new JLabel();
			jLabel1.setFont(new Font("Dialog", Font.BOLD, 18));
			jLabel1.setText(":");
			jLabel = new JLabel();
			jLabel.setText("Descrizione");
			txtOraCh = new JLabel();
			txtOraCh.setText("Orario di Chiusura");
			txtOraAp = new JLabel();
			txtOraAp.setText("Orario di Apertura");
			txtTel = new JLabel();
			txtTel.setText("Telefono");
			txtPos = new JLabel();
			txtPos.setText("Posizione Geografica");
			txtProvincia = new JLabel();
			txtProvincia.setText("Provincia");
			txtLocalit = new JLabel();
			txtLocalit.setText("Localit");
			txtCitta = new JLabel();
			txtCitta.setText("Citt");
			txtCAP = new JLabel();
			txtCAP.setText("CAP");
			txtIndirizzo = new JLabel();
			txtIndirizzo.setText("Indirizzo");
			txtNome = new JLabel();
			txtNome.setText("Nome Punto di Ristoro");
			datiPR = new JPanel();
			datiPR.setLayout(new GridBagLayout());
			datiPR.setBorder(new SoftBevelBorder(SoftBevelBorder.LOWERED));
			datiPR.add(txtNome, gridBagConstraints5);
			datiPR.add(txtIndirizzo, gridBagConstraints6);
			datiPR.add(txtCitta, gridBagConstraints7);
			datiPR.add(txtLocalit, gridBagConstraints8);
			datiPR.add(txtCAP, gridBagConstraints9);
			datiPR.add(txtProvincia, gridBagConstraints10);
			datiPR.add(txtPos, gridBagConstraints11);
			datiPR.add(txtTel, gridBagConstraints12);
			datiPR.add(txtOraAp, gridBagConstraints13);
			datiPR.add(txtOraCh, gridBagConstraints14);
			datiPR.add(jLabel, gridBagConstraints15);
			datiPR.add(getIndirizzoPR1(), gridBagConstraints16);
			datiPR.add(getIndirizzoPR(), gridBagConstraints17);
			datiPR.add(getCittaPR(), gridBagConstraints18);
			datiPR.add(getLocalitaPR(), gridBagConstraints19);
			datiPR.add(getCapPR(), gridBagConstraints20);
			datiPR.add(getProvPR(), gridBagConstraints21);
			datiPR.add(getTelefonoPR(), gridBagConstraints23);
			datiPR.add(getOrarioAPOrePR(), gridBagConstraints24);
			datiPR.add(jLabel1, gridBagConstraints25);
			datiPR.add(getOrarioApMinPR(), gridBagConstraints26);
			datiPR.add(jLabel3, gridBagConstraints28);
			datiPR.add(getOrarioCHMinPR(), gridBagConstraints29);
			datiPR.add(getJScrollPane(), gridBagConstraints30);
			datiPR.add(getNomePR(), gridBagConstraints31);
			datiPR.add(getJPanel(), gridBagConstraints32);
			datiPR.add(jLabel4, gridBagConstraints35);
			datiPR.add(jLabel41, gridBagConstraints36);
			datiPR.add(getPosGeoX(), gridBagConstraints22);
			datiPR.add(getPosGeoY(), gridBagConstraints38);
			datiPR.add(getPosGeoZ(), gridBagConstraints33);
			datiPR.add(jLabel2, gridBagConstraints34);
			datiPR.add(getOrarioCHOrePR(), gridBagConstraints27);
		}
		return datiPR;
	}

	/**
	 * Metodo per iniziailizzare un pannello (statistiche)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getStatistiche() {
		if (statistiche == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridwidth = 0;
			gridBagConstraints4.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.insets = new Insets(20, 0, 0, 0);
			gridBagConstraints4.gridy = 2;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridwidth = 2;
			gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.insets = new Insets(0, 0, 20, 0);
			gridBagConstraints3.gridy = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 1;
			gridBagConstraints2.insets = new Insets(0, 30, 30, 0);
			gridBagConstraints2.anchor = GridBagConstraints.WEST;
			gridBagConstraints2.gridy = 0;
			mediaVotoPR = new JLabel();
			mediaVotoPR.setText("JLabel");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.insets = new Insets(0, 0, 30, 0);
			gridBagConstraints1.gridy = 0;
			txtNomeBene = new JLabel();
			txtNomeBene.setText("<nome Bene Culturale>");
			txtNomeBene.setFont(new Font("Dialog", Font.BOLD, 18));
			statistiche = new JPanel();
			statistiche.setLayout(new GridBagLayout());
			statistiche.add(txtNomeBene, gridBagConstraints1);
			statistiche.add(mediaVotoPR, gridBagConstraints2);
			statistiche.add(getStatisticheMeseCorrente(), gridBagConstraints3);
			statistiche.add(getStatisticheTotali(), gridBagConstraints4);
		}
		return statistiche;
	}

	/**
	 * Metodo per inizializzare un pannello (feedback)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFeedback() {
		if (feedback == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.gridx = 0;
			feedback = new JPanel();
			feedback.setLayout(new GridBagLayout());
			feedback.add(getJScrollPane2(), gridBagConstraints);
		}
		return feedback;
	}

	/**
	 * Inizializziamo un JexField (indirizzoPR)	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getIndirizzoPR() {
		if (indirizzoPR == null) {
			indirizzoPR = new JTextField();
			indirizzoPR.setColumns(12);
			indirizzoPR.addActionListener(campoCompilato);
		}
		return indirizzoPR;
	}

	/**
	 * Metodo per inizializzare il campo tipo indirizzo (indirizzoPR)
	 * ossia via, piazza....	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getIndirizzoPR1() {
		if (indirizzoPR1 == null) {
			indirizzoPR1 = new JComboBox();
			indirizzoPR1.setPreferredSize(new Dimension(60, 20));
			indirizzoPR1.setMinimumSize(new Dimension(60, 25));
			indirizzoPR1.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			indirizzoPR1.addItem("Via");
			indirizzoPR1.addItem("P.zza");
			indirizzoPR1.addItem("V.le");
			indirizzoPR1.addItem("V.co");
			indirizzoPR1.addItem("Largo");
			indirizzoPR1.addItem("Corso");
					
		}
		return indirizzoPR1;
	}

	/**
	 * Inizializzazione di un jTextField per l'inserimento di
	 * uan citt CittaPR	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCittaPR() {
		if (cittaPR == null) {
			cittaPR = new JTextField();
			cittaPR.setColumns(12);
			cittaPR.addActionListener(campoCompilato);
		}
		return cittaPR;
	}

	/**
	 * This method initializes localitaPR	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getLocalitaPR() {
		if (localitaPR == null) {
			localitaPR = new JComboBox();
			localitaPR.setMinimumSize(new Dimension(80, 25));
			localitaPR.setPreferredSize(new Dimension(80, 20));
			localitaPR.addActionListener(campoCompilato);
		}
		return localitaPR;
	}

	/**
	 * Cap del punto di ristoro. Definizione del JTextField capPR	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCapPR() {
		if (capPR == null) {
			capPR = new JTextField();
			capPR.setColumns(8);
			capPR.addActionListener(campoCompilato);
		}
		return capPR;
	}

	/**
	 * creazione jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane.setViewportView(getDescrizionePR());
		}
		return jScrollPane;
	}

	/**
	 * metodo per la creazione dlela JTExtArea descrizionePR	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getDescrizionePR() {
		if (descrizionePR == null) {
			descrizionePR = new JTextArea();
			descrizionePR.setColumns(12);
			descrizionePR.setCursor(new Cursor(Cursor.TEXT_CURSOR));
			
		}
		return descrizionePR;
	}

	/**
	 * metodo per la creazione del JTextField telefonoPR	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTelefonoPR() {
		if (telefonoPR == null) {
			telefonoPR = new JTextField();
			telefonoPR.setColumns(12);
			telefonoPR.addActionListener(campoCompilato);
		}
		return telefonoPR;
	}

	/**
	 *metodo per inizializzare una JCombobox con le ore (orarioAPOrePR)
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getOrarioAPOrePR() {
		if (orarioAPOrePR == null) {
			orarioAPOrePR = new JComboBox();
			orarioAPOrePR.setPreferredSize(new Dimension(40, 20));
			for (int i = 0; i<24; i++) {
				if (i<10)
					orarioAPOrePR.addItem("0"+i);
				else
					orarioAPOrePR.addItem(i);
			
			}
			orarioAPOrePR.addActionListener(campoCompilato);
		}
		return orarioAPOrePR;
	}

	/**
	 * metodo per inizializzare una JCombobox con i minuti(orarioApMinPR)	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getOrarioApMinPR() {
		if (orarioApMinPR == null) {
			orarioApMinPR = new JComboBox();
			orarioApMinPR.setLightWeightPopupEnabled(true);
			orarioApMinPR.setPreferredSize(new Dimension(40, 20));
			orarioApMinPR.addItem("00");
			orarioApMinPR.addItem("15");
			orarioApMinPR.addItem("30");
			orarioApMinPR.addItem("45");
			orarioApMinPR.addActionListener(campoCompilato);
		}
		return orarioApMinPR;
	}



	/**
	 * metodo per inizializzare una JCombobox con i minuti (orarioCHMinPR)
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getOrarioCHMinPR() {
		if (orarioCHMinPR == null) {
			orarioCHMinPR = new JComboBox();
			orarioCHMinPR.setPreferredSize(new Dimension(40, 20));
			orarioCHMinPR.addItem("00");
			orarioCHMinPR.addItem("15");
			orarioCHMinPR.addItem("30");
			orarioCHMinPR.addItem("45");
			orarioCHMinPR.addActionListener(campoCompilato);
		}
		return orarioCHMinPR;
		
	}

	/**
	 * Crea e inizializza un jCombo Box con tutte le province (provPR)	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JComboBox getProvPR() {
		if (provPR == null) {
			final String[] province = {"AG","AL","AN","AO","AQ","AR","AP","AT","AV","BA","BL","BN","BG","BI","BO","BR","BS","BZ",
				"CA","CB","CE","CH","CI","CL","CN","CO","CR","CS","KR","EN","FC","FE","FI","FG","FR","GE","GO","GR","IM","IS","LC",
				"LE","LI","LO","LT","LU","MC","ME","MF","MN","MO","MS","MT","NA","NO","NU","OG","OR","OT","PA","PC","PD","PE","PG","PO","PR","PU","PV","RA","RC","RE","RG",
			"RI","RM","RN","RO","SA","SI","SO","SP","SS","SV","TA","TE","TN","TP","TR","TS","TV","UD","VA","VB","VC","VE","VI",
			"VR","VS","VT","VV"};
			provPR = new JComboBox();
			for (int i = 0; i < province.length; i++) {
				provPR.addItem(province[i]);
			}
			provPR.addActionListener(campoCompilato);
		}
		return provPR;
	}

	class DocumentoNumerico extends PlainDocument {
	    
	    
	    private int limit;
	    
	    
	    public DocumentoNumerico(int limit){
	    
	        this.limit = limit;
	        
	    }
	    
	    /**
		 * inizializzazione e gestione della posizione
		 * 	
		 * @param intero pOffset
		 * @param String pString
		 * @param Attriuto pAttr
		 * 	
		 */
	    public void insertString (int pOffset, String  pStr, AttributeSet pAttr) throws BadLocationException {
	        if (pStr == null) 
	            return;
	        
	        if ((getLength() + pStr.length()) <= limit) {
	           super.insertString(pOffset, pStr, pAttr);
	            }
	        }       
	   }
	   
	
	/**
	 * inizializzazione di uno dei dati del punto i ristoro (nomePR)	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNomePR() {
		if (nomePR == null) {
			nomePR = new JTextField();
			nomePR.setColumns(12);
			nomePR.setPreferredSize(new Dimension(180, 20));
			nomePR.addActionListener(campoCompilato);
			nomePR.addFocusListener(validating);
			nomePR.setDocument(new DocumentoNumerico(20));
		
		}
		return nomePR;
	}

	/**
	 * Inizializzazione e creazione di un pannello (jPanel)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BorderLayout());
			jPanel.setBorder(BorderFactory.createTitledBorder(
					BorderFactory.createEmptyBorder(), 
					"Tag di ricerca", TitledBorder.DEFAULT_JUSTIFICATION, 
					TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), 
					Color.black));
			BeanTag[] prova = new BeanTag[8];
			prova[0] = new BeanTag(0,"castello","veramente un castello");
			prova[1] = new BeanTag(1,"roccaforte","veramente un ostello");
			prova[2] = new BeanTag(3,"statua","veramente un cestello");
			prova[3] = new BeanTag(4,"colonna","veramente un cestello");
			prova[4] = new BeanTag(5,"interno","veramente un cestello");
			prova[5] = new BeanTag(6,"esterno","veramente un cestello");
			prova[6] = new BeanTag(7,"ottocento","veramente un cestello");
			prova[7] = new BeanTag(8,"novecento","veramente un cestello");
			pannelloTag = new TagPanel(prova);
			jPanel.add(pannelloTag, BorderLayout.CENTER);
		}
		return jPanel;
	}

	/**
	 *Creazione di un JScrollPane (jScrollPane2)	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane2.setViewportView(getFeedbackTable());
		}
		return jScrollPane2;
	}

	/**
	 * Creazione di una JTable (feedbackTable)	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getFeedbackTable() {
		if (feedbackTable == null) {
			feedbackTable = new JTable();
		}
		return feedbackTable;
	}

	/**
	 * Creazione di un pannello (statisticheMeseCorrente)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getStatisticheMeseCorrente() {
		if (statisticheMeseCorrente == null) {
			statisticheMeseCorrente = new JPanel();
			statisticheMeseCorrente.setLayout(new GridBagLayout());
			statisticheMeseCorrente.setPreferredSize(new Dimension(500, 120));
		}
		return statisticheMeseCorrente;
	}

	/**
	 * Creazione di un pannello (statisticheTotali)	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getStatisticheTotali() {
		if (statisticheTotali == null) {
			statisticheTotali = new JPanel();
			statisticheTotali.setLayout(new GridBagLayout());
			statisticheTotali.setPreferredSize(new Dimension(500, 120));
		}
		return statisticheTotali;
	}
	/**
	 * Metodo per la creazione di una toolbar
	 * (ToolbarSchedaPR)	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getToolbarSchedaPR() {
		if (ToolbarSchedaPR == null) {
			
			ToolbarSchedaPR = new JToolBar();
			ToolbarSchedaPR.setFloatable(false);
			ToolbarSchedaPR.add(getBtnModifica());
			ToolbarSchedaPR.addSeparator();
			ToolbarSchedaPR.add(getBtnSalva());
			ToolbarSchedaPR.addSeparator();
			ToolbarSchedaPR.add(getBtnAnnulla());
			ToolbarSchedaPR.addSeparator();
			ToolbarSchedaPR.add(getBtnModificaCommento());
			ToolbarSchedaPR.addSeparator();
		}
		return ToolbarSchedaPR;
	}
	/**
	 *  metodo per inizializzare posGeoX	
	 * la posizione X del GPS	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPosGeoX() {
		if (posGeoX == null) {
			posGeoX = new JTextField();
		}
		return posGeoX;
	}
	/**
	 * metodo per inizializzare posGeoY	
	 * la posizione Y del GPS
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPosGeoY() {
		if (posGeoY == null) {
			posGeoY = new JTextField();
		}
		return posGeoY;
	}
	/**
	 *  metodo per inizializzare posGeoZ	
	 * la posizione Z del GPS
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPosGeoZ() {
		if (posGeoZ == null) {
			posGeoZ = new JTextField();
		}
		return posGeoZ;
	}
	/**
	 * metodo per inizializzare una JCombobox con le ore (orarioCHOrePR)	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getOrarioCHOrePR() {
		if (orarioCHOrePR == null) {
			orarioCHOrePR = new JComboBox();
			orarioCHOrePR.setPreferredSize(new Dimension(40, 20));
		}
		return orarioCHOrePR;
	}

} 

