﻿package unisa.gps.etour.gui.operatoreagenzia;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import unisa.gps.etour.bean.BeanTurista;
import unisa.gps.etour.util.Data;

/**
 * Classe che modella l'interfaccia per la visualizzazione della scheda e 
 * la modifica dei dati di un account turista.
 *  
 * @version 1.0
 * @author Mario Gallo
 * 
 * &#169; 2007 eTour Project - Copyright by SE@SA Lab DMI -
 *         University of Salerno
 */
public class scheda turista extends JInternalFrame implements IScheda
{

	private static final String[] help = { "", "", "", "", "", "", "", "", "",
			"", "", "", "", "" };
	private JPanel jContentPane = null;
	private JToolBar toolbarscheda turista = null;
	private JToggleButton btnModifica = null;
	private JButton btnSalva = null;
	private JButton btnReimposta = null;
	private JTabbedPane jTabbedPane = null;
	private JTextField indirizzo2 = null;
	private JComboBox indirizzo1 = null;
	private JTextField citta = null;
	private JTextField cap = null;
	private JTextField telefono = null;
	private JComboBox provincia = null;
	private JPanel datiTurista = null;
	private JTextField nome = null;
	private Vector<JLabel> suggerimenti;
	private BeanTurista turista;
	private JTextField cognome;
	private JComboBox giorno;
	private JComboBox mese;
	private JComboBox anno;
	private JTextField luogoNascita;
	private JTextField email;
	private JTextField username;
	private JPasswordField password;
	private JLabel dataRegistrazione;
	private Turisti parent;

	/**
	 * 
	 * L'unico costruttore modella la scheda di un turista o la modifica dei dati
	 * a partire dal bean.
	 * 
	 * @param pParent unisa.gps.etour.gui.operatoreagenzia.Turisti - la finestra "padre".
	 * @param pTurista unisa.gps.etour.bean.BeanTurista - il bean contentente i dati
	 * del turista.
	 * @param  pModifica boolean<ul><li>true - se si procede alla modifica dei 
	 * dati.<li>false - se si sta visualizzando la scheda.	    
	 * 
	 */
	public scheda turista(Turisti pParent, BeanTurista pTurista,
			boolean pModifica)
	{
		super();
		this.parent = pParent;
		setIconifiable(true);
		setSize(560, 520);
		suggerimenti = new Vector<JLabel>();
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		setClosable(true);
		turista = pTurista;
		if (turista.isAttiva())
		{
			frameIcon = new ImageIcon(
					getClass()
							.getResource(
									"/unisa/gps/etour/gui/operatoreagenzia/images/scheda turista.png"));
		}
		else
		{
			frameIcon = new ImageIcon(
					getClass()
							.getResource(
									"/unisa/gps/etour/gui/operatoreagenzia/images/DisattivaTurista32.png"));
		}
		initialize();
		if (pModifica)
		{
			btnModifica.setSelected(true);
			btnSalva.setVisible(true);
			btnReimposta.setVisible(true);
		}
		else
		{
			mostraNascondiSuggerimenti();
			attivaDisattivaEdit();
		}
		addInternalFrameListener(new InternalFrameAdapter()
		{
			public void internalFrameClosing(InternalFrameEvent pEvent)
			{
				if (btnModifica.isSelected())
				{
					JPanel root = new JPanel(new BorderLayout());
					JLabel message = new JLabel(
						"Sei sicuro di voler chiudere la scheda di questo turista?");
					message.setFont(new Font("Dialog", Font.BOLD, 14));
					JLabel avviso = new JLabel(
						"Attenzione! I dati non salvati verranno persi.", SwingConstants.CENTER);
					avviso.setIcon(new ImageIcon(getClass().getResource(
						"/unisa/gps/etour/gui/operatoreagenzia/images/warning16.png")));
					root.add(message, BorderLayout.NORTH);
					root.add(avviso, BorderLayout.SOUTH);
					String[] options = { "Chiudi", "Annulla" };
					int choice = JOptionPane.showInternalOptionDialog(jContentPane, root, 
							"Conferma chiusura Scheda Turista " + turista.getNome() + " " + turista.getCognome(),
							JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, frameIcon, options, options[1]);  
					if (choice == JOptionPane.OK_OPTION)
					{
						parent.closeScheda((scheda turista)pEvent.getInternalFrame());
					}
				}
				else 
				{
					parent.closeScheda((scheda turista)pEvent.getInternalFrame());	
				}
			}
		});
	}

	/**
	 * 
	 * Questo metodo inizializza l'interfaccia della scheda di un turista.
	 * 
	 * @return void
	 * 
	 */
	private void initialize()
	{
		jContentPane = new JPanel();
		jContentPane.setLayout(new BorderLayout());
		jContentPane.add(getToolbarscheda turista(), BorderLayout.SOUTH);
		jTabbedPane = new JTabbedPane();
		jTabbedPane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		jTabbedPane.addTab("Dati Turista", frameIcon, getDatiTuristaForm(),
				null);
		jContentPane.add(jTabbedPane, BorderLayout.CENTER);
		setContentPane(jContentPane);
		caricaDatiForm();
	}

	/**
	 * 
	 * Questo metodo carica i dati del bean turista fornito nei campi
	 * della form.
	 * 
	 * @return void
	 *
	 */
	private void caricaDatiForm()
	{
		setTitle("Profilo Turista - " + turista.getNome() + " "
				+ turista.getCognome());
		nome.setText(turista.getNome());
		cognome.setText(turista.getCognome());
		Date dataNascita = turista.getDataNascita();
		giorno.setSelectedIndex(dataNascita.getDate());
		mese.setSelectedIndex(dataNascita.getMonth());
		anno.setSelectedIndex(dataNascita.getYear());
		StringTokenizer tokenizer = new StringTokenizer(turista.getVia());
		String stringa = tokenizer.nextToken();
		indirizzo1.setSelectedItem(stringa);
		indirizzo2.setText(turista.getVia().substring(stringa.length()));
		luogoNascita.setText(turista.getCittaNascita());
		telefono.setText(turista.getTelefono());
		citta.setText(turista.getCittaResidenza());
		password.setText(turista.getPassword());
		provincia.setSelectedItem(turista.getProvincia());
		username.setText(turista.getUsername());
		cap.setText(turista.getCap());
		email.setText(turista.getEmail());
		dataRegistrazione
				.setText(Data.toEstesa(turista.getDataRegistrazione()));
	}

	/**
	 * 
	 * Questo metodo mostra o nasconde i suggerimenti relativi ai campi della form.
	 * 
	 * @return void
	 *
	 */
	private void mostraNascondiSuggerimenti()
	{
		Iterator<JLabel> s = suggerimenti.iterator();
		while (s.hasNext())
		{
			JLabel corrente = s.next();
			corrente.setVisible(corrente.isVisible() ? false : true);
		}
	}

	/**
	 * 
	 * Questo metodo rende editabili o meno i campi della form.
	 * 
	 * @return void
	 *
	 */
	private void attivaDisattivaEdit()
	{
		Component[] componenti = datiTurista.getComponents();
		for (int i = 0; i < componenti.length; i++)
		{
			Component corrente = componenti[i];
			if (corrente instanceof JTextField)
			{
				JTextField textbox = (JTextField) corrente;
				textbox.setEditable(textbox.isEditable() ? false : true);
				textbox.setBackground(Color.white);

			}
			else if (corrente instanceof JComboBox)
			{
				JComboBox combobox = (JComboBox) corrente;
				combobox.setEnabled(combobox.isEnabled() ? false : true);

			}
		}
	}

	/**
	 * Questo metodo inizializza la toolbar per le funzionalit� della scheda
	 * turista.	
	 * 	
	 * @return javax.swing.JToolBar
	 * 
	 */
	private JToolBar getToolbarscheda turista()
	{
		if (toolbarscheda turista == null)
		{
			toolbarscheda turista = new JToolBar();
			toolbarscheda turista.setFloatable(false);
			toolbarscheda turista.add(getBtnModifica());
			toolbarscheda turista.addSeparator();
			toolbarscheda turista.add(getBtnSalva());
			toolbarscheda turista.addSeparator();
			toolbarscheda turista.add(getBtnReimposta());
			toolbarscheda turista.addSeparator();
		}
		return toolbarscheda turista;
	}

	/**
	 * Questo metodo inizializza il pulsante per la modifica dei dati.	
	 * 	
	 * @return javax.swing.JToggleButton
	 *  
	 */
	private JToggleButton getBtnModifica()
	{
		if (btnModifica == null)
		{
			btnModifica = new JToggleButton();
			btnModifica.setText("Modifica Dati");
			btnModifica
					.setIcon(new ImageIcon(
							getClass()
									.getResource(
											"/unisa/gps/etour/gui/operatoreagenzia/images/ModificaTurista32.png")));
			btnModifica
					.setToolTipText("Attiva o disattiva la modifica dei dati del turista selezionato.");
			btnModifica.addActionListener(new ActionListener()
			{

				public void actionPerformed(ActionEvent arg0)
				{
					mostraNascondiSuggerimenti();
					attivaDisattivaEdit();
					btnSalva.setVisible((btnModifica.isSelected() ? true
							: false));
					btnReimposta.setVisible((btnModifica.isSelected() ? true
							: false));

				}

			});
		}
		return btnModifica;
	}

	/**
	 * Questo metodo inizializza il pulsante per il salvataggio delle modifiche
	 * apportate ai dati del turista.	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnSalva()
	{
		if (btnSalva == null)
		{
			btnSalva = new JButton();
			btnSalva.setText("Salva");
			btnSalva.setIcon(new ImageIcon(getClass().getResource(
					"/unisa/gps/etour/gui/operatoreagenzia/images/salva.png")));
			btnSalva
					.setToolTipText("Salva le modifiche apportate al profilo turista selezionato.");
			btnSalva.setVisible(false);
			btnSalva.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent pEvent)
				{
					//Costruzione della dialog per la conferma della modifica
					JPanel root = new JPanel(new BorderLayout());
					JLabel message = new JLabel(
							"Aggiornare il profilo Turista di"
									+ turista.getNome() + " "
									+ turista.getCognome() + " con i"
									+ " dati della form?");
					message.setFont(new Font("Dialog", Font.BOLD, 14));
					JLabel avviso = new JLabel(
							"I dati precedenti non potranno essere pi� recuperati.",
							SwingConstants.CENTER);
					avviso
							.setIcon(new ImageIcon(
									getClass()
											.getResource(
													"/unisa/gps/etour/gui/operatoreagenzia/images/warning16.png")));
					root.add(message, BorderLayout.NORTH);
					root.add(avviso, BorderLayout.SOUTH);
					String[] options = { "Modifica", "Annulla" };
					//La dialog viene visualizzata a schermo
					int scelta = JOptionPane
							.showInternalOptionDialog(
									jContentPane,
									root,
									"Conferma Modifica Dati Turista",
									JOptionPane.YES_NO_OPTION,
									JOptionPane.QUESTION_MESSAGE,
									new ImageIcon(
											getClass()
													.getResource(
															"/unisa/gps/etour/gui/operatoreagenzia/images/ModificaTurista48.png")),
									options, options[1]);
					//Se si � scelto di confermare la modifica
					if (scelta == JOptionPane.YES_OPTION)
					{
						turista.setNome(nome.getText());
						turista.setCognome(cognome.getText());
						turista.setCap(cap.getText());
						turista.setCittaNascita(luogoNascita.getText());
						turista.setDataNascita(new Date(
								anno.getSelectedIndex(), mese
										.getSelectedIndex(), giorno
										.getSelectedIndex()));
						turista.setCittaResidenza(citta.getText());
						turista.setUsername(username.getText());
						turista.setEmail(email.getText());
						turista.setTelefono(telefono.getText());
						turista.setVia(indirizzo1.getSelectedItem().toString()
								+ " " + indirizzo2.getText());
						turista.setProvincia(provincia.getSelectedItem()
								.toString());
						String pass = "";
						char[] passWord = password.getPassword();
						for (int i = 0; i < passWord.length; i++)
						{
							pass += passWord[i];
						}
						turista.setPassword(pass);
						caricaDatiForm();
						attivaDisattivaEdit();
						btnSalva.setVisible(false);
						btnReimposta.setVisible(false);
						btnModifica.setSelected(false);
						mostraNascondiSuggerimenti();
						parent.updateTableModel(turista);
						JOptionPane
								.showInternalMessageDialog(
										jContentPane,
										"I dati del turista sono stati aggiornati correttamente.",
										"Profilo Turista Modificato!",
										JOptionPane.OK_OPTION,
										new ImageIcon(
												getClass()
														.getResource(
																"/unisa/gps/etour/gui/operatoreagenzia/images/ok48.png")));
					}
				}
			});
		}
		return btnSalva;
	}

	/**
	 * Questo metodo inizializza il pulsante per reimpostare i dati del turista
	 * nella form.	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnReimposta()
	{
		if (btnReimposta == null)
		{
			btnReimposta = new JButton();
			btnReimposta.setText("Reimposta");
			btnReimposta
					.setIcon(new ImageIcon(
							getClass()
									.getResource(
											"/unisa/gps/etour/gui/operatoreagenzia/images/Annulla32.png")));
			btnReimposta
					.setToolTipText("Ricarica i dati del turista selezionato.");
			btnReimposta.setVisible(false);
			btnReimposta.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent arg0)
				{
					caricaDatiForm();
				}
			});
		}
		return btnReimposta;
	}

	/**
	 * Questo metodo inizializza la form contentente i dati del turista.	
	 * 	
	 * @return javax.swing.JPanel	
	 * 
	 */
	private JPanel getDatiTuristaForm()
	{
		if (datiTurista == null)
		{
			datiTurista = new JPanel(null);
			datiTurista.setBorder(new SoftBevelBorder(SoftBevelBorder.LOWERED));
			//Creazione Suggerimenti
			String[] txts = { "Nome", "Cognome", "Data di Nascita",
					"Luogo di Nascita", "Telefono", "Indirizzo", "Citt�",
					"CAP", "Provincia", "E-Mail", "Username", "Password",
					"Registrato il" };

			for (int i = 0; i < help.length; i++)
			{
				JLabel nuova = new JLabel();
				nuova.setIcon(new ImageIcon(getClass().getResource(
						"/unisa/gps/etour/gui/images/Info16.png")));
				nuova.setBounds(145, 8 + 30 * i, 24, 24);
				nuova.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
				nuova.setToolTipText(help[i]);
				suggerimenti.add(nuova);
				datiTurista.add(nuova);

			}

			for (int i = 0; i < txts.length; i++)
			{
				JLabel nuova = new JLabel(txts[i], SwingConstants.RIGHT);
				nuova.setBounds(25, 10 + 30 * i, 120, 20);
				nuova.repaint();
				datiTurista.add(nuova, null);
			}
			//Nome
			nome = new JTextField(12);
			nome.setBounds(185, 10, 136, 20);
			nome.setName("Nome");
			datiTurista.add(nome, null);

			//Cognome
			cognome = new JTextField(12);
			cognome.setBounds(185, 40, 136, 20);
			cognome.setName("Cognome");
			datiTurista.add(cognome, null);

			//Data di nascita
			giorno = new JComboBox();
			giorno.setBounds(185, 70, 40, 20);
			for (int i = 1; i <= 31; i++)
			{
				giorno.addItem(i);
			}
			mese = new JComboBox();
			mese.addActionListener(new ActionListener()
			{

				public void actionPerformed(ActionEvent pEvent)
				{
					int numero = giorno.getItemCount();
					switch (mese.getSelectedIndex())
					{
						case 0:
						case 2:
						case 4:
						case 6:
						case 7:
						case 9:
						case 11:
							for (int i = numero + 1; i <= 31; i++)
							{
								giorno.addItem(i);
							}
						break;

						case 1:
							int year = (Integer) anno.getSelectedItem();
							boolean bisestile = ((year % 4 == 0 && year % 100 != 0) || (year % 400 == 0));
							if (numero != 28)
							{
								for (int i = numero - 1; i > 27; i--)
								{
									giorno.removeItemAt(i);
								}
							}
							if (bisestile && numero != 29)
							{
								giorno.addItem("29");
							}
						break;

						case 3:
						case 5:
						case 8:
						case 10:
							if (numero == 31)
							{
								giorno.removeItemAt(30);
							}
							else
							{
								for (int i = numero + 1; i <= 30; i++)
								{
									giorno.addItem(i);
								}
							}
						break;
					}
				}

			});
			mese.setBounds(245, 70, 40, 20);
			for (int i = 1; i <= 12; i++)
			{
				mese.addItem(i);
			}
			anno = new JComboBox();
			anno.addActionListener(new ActionListener()
			{

				public void actionPerformed(ActionEvent arg0)
				{
					if (mese.getSelectedIndex() == 1)
					{
						int year = (Integer) anno.getSelectedItem();
						boolean bisestile = ((year % 4 == 0 && year % 100 != 0) || (year % 400 == 0));
						int numero = giorno.getItemCount();
						if (bisestile && numero != 29)
						{
							giorno.addItem("29");
						}
						else if (!bisestile && numero == 29)
						{
							giorno.removeItemAt(28);
						}
					}

				}

			});
			anno.setBounds(305, 70, 80, 20);
			Date odierna = new Date();
			for (int i = 0; i <= odierna.getYear() - 14; i++)
			{
				anno.addItem(1900 + i);
			}
			datiTurista.add(giorno, null);
			datiTurista.add(mese, null);
			datiTurista.add(anno, null);

			//Luogo di Nascita
			luogoNascita = new JTextField(12);
			luogoNascita.setBounds(185, 100, 136, 20);
			luogoNascita.setName("Luogo Nascita");
			datiTurista.add(luogoNascita, null);

			//Telefono
			telefono = new JTextField(12);
			telefono.setBounds(185, 130, 136, 20);
			telefono.setName("Telefono");
			datiTurista.add(telefono, null);

			//Indirizzo
			indirizzo2 = new JTextField(12);
			indirizzo2.setBounds(270, 160, 136, 20);
			indirizzo1 = new JComboBox(INDIRIZZI);
			indirizzo1.setSelectedIndex(-1);
			indirizzo1.setBounds(185, 160, 60, 20);
			datiTurista.add(indirizzo2, null);
			datiTurista.add(indirizzo1, null);

			//Citt�
			citta = new JTextField(12);
			citta.setBounds(185, 190, 136, 20);
			citta.setName("Citt�");
			datiTurista.add(citta, null);

			//CAP
			cap = new JTextField(8);
			cap.setBounds(185, 220, 92, 20);
			datiTurista.add(cap, null);

			//Provincia
			provincia = new JComboBox(PROVINCE);
			provincia.setSelectedIndex(-1);
			provincia.setBounds(185, 250, 50, 20);
			datiTurista.add(provincia, null);

			//E-Mail
			email = new JTextField();
			email.setBounds(185, 280, 200, 20);
			email.setName("E-Mail");
			datiTurista.add(email, null);

			//Username
			username = new JTextField();
			username.setBounds(185, 310, 136, 20);
			username.setName("Username");
			datiTurista.add(username, null);

			//Password
			password = new JPasswordField(12);
			password.setBounds(185, 340, 136, 20);
			password.setName("Password");
			datiTurista.add(password, null);

			//Data Registrazione
			dataRegistrazione = new JLabel();
			dataRegistrazione.setBounds(185, 370, 140, 20);
			datiTurista.add(dataRegistrazione, null);
		}
		return datiTurista;
	}

	/**
	 * Questo metodo ritorna l'id del turista che si sta visualizzando / 
	 * modificando.
	 * 
	 * @return int - l'id del turista.
	 * 
	 */
	public int getId()
	{
		return turista.getId();
	}
}
