/*
 * SitoTableModel.java
 *
 * 1.0
 *
 * 21/05/2007
 *
 *  2007 eTour Project - Copyright by SE@SA Lab - DMI  University of Salerno
 */
package Palmare;

import Bean.BeanPuntoDiRistoro;
import javax.swing.table.AbstractTableModel;
import Bean.*;
import Util.Punto3D;

/**
 * <b>SitoTableModel</b>
 * <p>Funge da contenitore dei dati dei beni culturali o dei punti di ristoro che devono
 * essere visualizzati in una JTable.</p>
 * @see javax.swing.table.AbstractTableModel
 * @see javax.swing.JTable
 * @see unisa.gps.etour.bean.BeanBeneCulturale
 * @see unisa.gps.etour.bean.BeanPuntoDiRistoro
 * @version 1.0
 * @author Landi Raffaele
 */

public class SitoTableModel extends AbstractTableModel{
    String[] columnNames = {"Nome",
    "Citt","Distanza"};
    Object[][] cells;
    Punto3D posizioneSito;
    Punto3D miaPosizione;
    
    SitoTableModel(BeanPuntoDiRistoro[] pr, Punto3D miaPosizione){
        super();
        cells=new Object[pr.length][3]; // Prima valore = righe     secondo=colonne
        for(int i=0;i<pr.length;i++){
            cells[i][0]=pr[i].getNome();
            cells[i][1]=pr[i].getCitta();
            
            
            
            
        }
    }
    
    SitoTableModel(BeanBeneCulturale[] bc, Punto3D miaPosizione){
        super();
        cells=new Object[bc.length][3]; // Prima valore = righe     secondo=colonne
        for(int i=0;i<bc.length;i++){
            cells[i][0]=bc[i].getNome();
            cells[i][1]=bc[i].getCitta();
            
        }
    }
    
    public int getRowCount(){
        return cells.length;
    }
    
    public int getColumnCount(){
        return columnNames.length;
    }
    
    public Object getValueAt(int r, int c){
        if (c < columnNames.length - 1)
            return cells[r][c];
        else{
            double value=miaPosizione.distanza(posizioneSito);
            return new Double(value);
        }
        
    }
    
    public String getColumnName(int c){
        return columnNames[c];
    }
}



