/*
* TAGTableModel.java
*
* 1.0
*
* 28/05/2007
*
*  2007 eTour Project - Copyright by SE@SA Lab - DMI  University of Salerno
*/
package unisa.gps.etour.gui.operatoreagenzia;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import unisa.gps.etour.bean.BeanTag;
/**
* <p>
* <B>Title:</B> TagTableModel
* </p>
* <p>
* <B>Description:</B> TableModel per la gestione dinamica della Table
* all'interno della sezione GestioneTag
* </p>
* 
* @author _Lello_
* @version 1.0
*/

public class TAGTableModel extends AbstractTableModel {

	
	private static final long serialVersionUID = 1L;
	private static final String[] headers = 
		{"Nome","Descrizione"};
	private static final Class[] columnClasses = 
		{String.class,String.class};
	private Vector<Object[]> data;
	
	/**
	 * Costruttore per la classe TagTableModel
	 * 
	 * @param BeanTag[]
	 *           
	 */
	public TAGTableModel(BeanTag[] tag) 
	{
		data = new Vector<Object[]>();
		for (int i = 0; i < tag.length; i++) 
		{
			Object[] nuovo = new Object[10];
			nuovo[0] = tag[i].getId();
			nuovo[1] = tag[i].getName();
			nuovo[2] = tag[i].getDescrizione();
			
		}
	}
	
	/**
	 * Restituisce il numero di colonne
	 * 
	 */
	public int getColumnCount() {
		return headers.length;
	}

	/**
	 * Restituisce il numero di righe
	 * 
	 */
	public int getRowCount() {
		return data.size();
	}
	
	/**
	 * Restituisce l'intestazione della colonna i_esima
	 * 
	 * @param pCol
	 * 
	 */
	public String getColumnName(int pCol) {
		return headers[pCol];
	}

	/**
	 * Restituisce l'oggetto dato dalla coppia di coordinate riga,colonna
	 * 
	 * @param pCol
	 * @param pRow
	 * 
	 */
	public Object getValueAt(int pRow, int pCol) {
		return data.get(pRow)[pCol];
	}
	
	/**
	 * Restituisce la classe della colonna pCol
	 * 
	 * @param pCol
	 * 
	 */
	public Class getColumnClass(int pCol) {
		return columnClasses[pCol];
	}
	
	/**
	 * Restituisce sempre falso perche le celle della table non sono editabili
	 * 
	 * @param pCol
	 * @param pRow
	 * 
	 * @return false
	 * 
	 */
	public boolean isCellEditable(int row, int col) {
		return false;
	}
	
	/**
	 * Questo metodo  vuoto.
	 *  Non pu essere inserito un elemento all'interno di una cella
	 *  
	 * @deprecated
	 * 
	 */
	public void setValueAt(Object value, int row, int col) {
		
	}
	
}
