package unisa.gps.etour.gui.operatoreagenzia;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JInternalFrame;

import unisa.gps.etour.bean.BeanTag;

import java.awt.GridBagLayout;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JTextPane;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import java.awt.Insets;

public class Tag extends JInternalFrame
{

	private JPanel jContentPane = null;
	private JPanel CenterPanel = null;
	private JPanel EastPanel = null;
	private JScrollPane jScrollPane = null;
	private JTable jTable = null;
	private JToolBar jJToolBarBar = null;
	private JButton btnModifica = null;
	private JButton btnElimina = null;
	private JButton btnExit = null;
	private JPanel jPanelUp = null;
	private JPanel jPanelHelp = null;
	private JTextPane jTextPane = null;
	private JLabel Nometag = null;
	private JTextField jTextField = null;
	private JLabel Descrizione = null;
	private JTextArea jTextArea = null;
	private JButton btnOk = null;
	private JButton btnResetta = null;

	/**
	 * This is the xxx default constructor
	 */
	public Tag()
	{
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		this.setSize(508, 398);
		this.setFrameIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/Properties.png")));
		this.setTitle("Gestione Tag");
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getCenterPanel(), BorderLayout.CENTER);
			jContentPane.add(getEastPanel(), BorderLayout.EAST);
			jContentPane.add(getJJToolBarBar(), BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes CenterPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getCenterPanel()
	{
		if (CenterPanel == null)
		{
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.weightx = 1.0;
			CenterPanel = new JPanel();
			CenterPanel.setLayout(new GridBagLayout());
			CenterPanel.add(getJScrollPane(), gridBagConstraints);
			
			
		}
		return CenterPanel;
	}

	/**
	 * This method initializes EastPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getEastPanel()
	{
		if (EastPanel == null)
		{
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridy = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 0;
			EastPanel = new JPanel();
			EastPanel.setLayout(new GridBagLayout());
			EastPanel.add(getJPanelUp(), gridBagConstraints2);
			EastPanel.add(getJPanelHelp(), gridBagConstraints3);
		}
		return EastPanel;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane()
	{
		if (jScrollPane == null)
		{
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTable()
	{
		if (jTable == null)
		{
			jTable = new JTable();
			BeanTag[] listaTag= new BeanTag[11];
			listaTag[0]=new BeanTag(1,"romantico","luogo per coppie e per momenti indimenticabili");
			listaTag[1]=new BeanTag(2,"esoterico","luoghi di magia");
			listaTag[2]=new BeanTag(3,"pizzeria","Le migliori pizzerie");
			listaTag[3]=new BeanTag(6,"musica","Locali con musica live, concerti...");
			listaTag[4]=new BeanTag(76,"trattoria","cucina tipica");
			listaTag[5]=new BeanTag(7,"fiere","per acquisti importanti o per bellismi souvenir");
			listaTag[6]=new BeanTag(9,"mercatini","cucina tipica");
			listaTag[7]=new BeanTag(8,"Storia","cucina tipica");
			listaTag[8]=new BeanTag(5,"Ottocento","cucina tipica");
			listaTag[9]=new BeanTag(4,"All'aperto","cucina tipica");
			listaTag[10]=new BeanTag(56,"Cinema","cucina tipica");
			
		}
		return jTable;
	}

	/**
	 * This method initializes jJToolBarBar	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getJJToolBarBar()
	{
		if (jJToolBarBar == null)
		{
			jJToolBarBar = new JToolBar();
			jJToolBarBar.add(getBtnModifica());
			jJToolBarBar.add(getBtnElimina());
			jJToolBarBar.addSeparator();
			jJToolBarBar.add(getBtnExit());
			
		}
		return jJToolBarBar;
	}

	/**
	 * This method initializes btnModifica	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnModifica()
	{
		if (btnModifica == null)
		{
			btnModifica = new JButton();
			btnModifica.setText("Modifica Tag");
			btnModifica.setIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/edit-32x32.png")));
		}
		return btnModifica;
	}

	/**
	 * This method initializes btnElimina	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnElimina()
	{
		if (btnElimina == null)
		{
			btnElimina = new JButton();
			btnElimina.setText("Elimina Tag");
			btnElimina.setIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/button-cancel-32x32.png")));
		}
		return btnElimina;
	}

	/**
	 * This method initializes btnExit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnExit()
	{
		if (btnExit == null)
		{
			btnExit = new JButton();
			btnExit.setText("Esci");
			btnExit.setIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/Forward 2.png")));
		}
		return btnExit;
	}

	/**
	 * This method initializes jPanelUp	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelUp()
	{
		if (jPanelUp == null)
		{
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 1;
			gridBagConstraints9.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints9.gridy = 4;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints8.gridy = 4;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridy = 3;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.weighty = 1.0;
			gridBagConstraints7.gridwidth = 2;
			gridBagConstraints7.insets = new Insets(5, 0, 5, 0);
			gridBagConstraints7.gridx = 0;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridwidth = 2;
			gridBagConstraints6.insets = new Insets(5, 0, 5, 0);
			gridBagConstraints6.gridy = 2;
			Descrizione = new JLabel();
			Descrizione.setText("Descrizione:");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints5.gridy = 1;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.gridwidth = 2;
			gridBagConstraints5.insets = new Insets(5, 0, 5, 0);
			gridBagConstraints5.gridx = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridwidth = 2;
			gridBagConstraints4.insets = new Insets(5, 0, 5, 0);
			gridBagConstraints4.gridy = 0;
			Nometag = new JLabel();
			Nometag.setText("Nome Tag:");
			jPanelUp = new JPanel();
			jPanelUp.setLayout(new GridBagLayout());
			jPanelUp.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(0, 102, 255), 3), "Inserimento Nuovo", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(0, 102, 255)));
			jPanelUp.add(Nometag, gridBagConstraints4);
			jPanelUp.add(getJTextField(), gridBagConstraints5);
			jPanelUp.add(Descrizione, gridBagConstraints6);
			jPanelUp.add(getJTextArea(), gridBagConstraints7);
			jPanelUp.add(getBtnOk(), gridBagConstraints8);
			jPanelUp.add(getBtnResetta(), gridBagConstraints9);
		}
		return jPanelUp;
	}

	/**
	 * This method initializes jPanelHelp	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelHelp()
	{
		if (jPanelHelp == null)
		{
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.weightx = 1.0;
			jPanelHelp = new JPanel();
			jPanelHelp.setLayout(new GridBagLayout());
			jPanelHelp.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(0, 102, 255), 3), "Guida in linea", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 153, 255)));
			jPanelHelp.add(getJTextPane(), gridBagConstraints1);
		}
		return jPanelHelp;
	}

	/**
	 * This method initializes jTextPane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getJTextPane()
	{
		if (jTextPane == null)
		{
			jTextPane = new JTextPane();
			jTextPane.setPreferredSize(new Dimension(190, 80));
		}
		return jTextPane;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField()
	{
		if (jTextField == null)
		{
			jTextField = new JTextField();
			jTextField.setColumns(10);
		}
		return jTextField;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea()
	{
		if (jTextArea == null)
		{
			jTextArea = new JTextArea();
			jTextArea.setRows(3);
		}
		return jTextArea;
	}

	/**
	 * This method initializes btnOk	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnOk()
	{
		if (btnOk == null)
		{
			btnOk = new JButton();
			btnOk.setText("Ok");
			btnOk.setIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/Button_ok16.png")));
		}
		return btnOk;
	}

	/**
	 * This method initializes btnResetta	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtnResetta()
	{
		if (btnResetta == null)
		{
			btnResetta = new JButton();
			btnResetta.setText("Resetta");
			btnResetta.setIcon(new ImageIcon(getClass().getResource("/interfacceAgenzia/immagini/Trash.png")));
		}
		return btnResetta;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
